function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/*
 * @Des:锁屏组件
 * @Author: chenzenghua
 * @Date: 2021-07-26 11:38:55
 * @Last Modified by: chenzenghua
 * @Last Modified time: 2021-09-18 14:28:25
 */

import { BorderOutlined, CloseOutlined, MinusOutlined } from '@ant-design/icons';
import classNames from 'classnames';
import React, { useEffect, useState } from 'react';
import "./styles.less";
var ControlPanel = function ControlPanel(props) {
  var _window7;
  var _useState = useState('Normal'),
    _useState2 = _slicedToArray(_useState, 2),
    status = _useState2[0],
    setStatus = _useState2[1];
  useEffect(function () {
    var _window;
    if ((_window = window) !== null && _window !== void 0 && _window.cefJs) {
      var _window2, _window2$getWindowSta;
      var ref = (_window2 = window) === null || _window2 === void 0 || (_window2 = _window2.cefJs) === null || _window2 === void 0 || (_window2$getWindowSta = _window2.getWindowState) === null || _window2$getWindowSta === void 0 ? void 0 : _window2$getWindowSta.call(_window2);
      setStatus(ref);
      //监听浏览器宽度的改变
      window.onresize = function () {
        var _window3, _window3$getWindowSta;
        var ref = (_window3 = window) === null || _window3 === void 0 || (_window3 = _window3.cefJs) === null || _window3 === void 0 || (_window3$getWindowSta = _window3.getWindowState) === null || _window3$getWindowSta === void 0 ? void 0 : _window3$getWindowSta.call(_window3);
        if (ref !== status) {
          setStatus(ref);
        }
      };
    }
  }, []);
  var onMaxNormalWindow = function onMaxNormalWindow() {
    var _window4, _window4$maxOrNormalW;
    var ref = (_window4 = window) === null || _window4 === void 0 || (_window4 = _window4.cefJs) === null || _window4 === void 0 || (_window4$maxOrNormalW = _window4.maxOrNormalWindow) === null || _window4$maxOrNormalW === void 0 ? void 0 : _window4$maxOrNormalW.call(_window4);
    setStatus(ref);
    // setStatus(status === 'Normal' ? '' : 'Normal')
  };
  var onMinWindow = function onMinWindow() {
    var _window5, _window5$minWindow;
    (_window5 = window) === null || _window5 === void 0 || (_window5 = _window5.cefJs) === null || _window5 === void 0 || (_window5$minWindow = _window5.minWindow) === null || _window5$minWindow === void 0 || _window5$minWindow.call(_window5);
  };
  var onCloseWindow = function onCloseWindow() {
    var _window6, _window6$closeWindow;
    (_window6 = window) === null || _window6 === void 0 || (_window6 = _window6.cefJs) === null || _window6 === void 0 || (_window6$closeWindow = _window6.closeWindow) === null || _window6$closeWindow === void 0 || _window6$closeWindow.call(_window6);
  };
  if ((_window7 = window) !== null && _window7 !== void 0 && _window7.cefJs && status !== 'Normal' || props.hidden === false) {
    return /*#__PURE__*/React.createElement("div", {
      className: classNames('xinherc-controlPanel', _defineProperty(_defineProperty({}, 'size-' + props.size, props.size), 'theme-' + props.theme, props.theme)),
      style: props.style
    }, props.disableMinBtn !== true && /*#__PURE__*/React.createElement("div", {
      className: "btn",
      onClick: onMinWindow
    }, /*#__PURE__*/React.createElement(MinusOutlined, null)), props.disableMaxBtn !== true && /*#__PURE__*/React.createElement("div", {
      className: "btn",
      onClick: onMaxNormalWindow
    }, status === 'Normal' ? /*#__PURE__*/React.createElement(BorderOutlined, null) : /*#__PURE__*/React.createElement("svg", {
      viewBox: "0 0 1024 1024",
      focusable: "false",
      "data-icon": "minus",
      width: "1em",
      height: "1em",
      fill: "currentColor",
      "aria-hidden": "true"
    }, /*#__PURE__*/React.createElement("path", {
      d: "m959.72,0l-665.504,0a63.96,63.96 0 0 0 -63.96,63.96l0,127.92l-165.976,0a63.96,63.96 0 0 0 -63.96,63.96l0,703.56a63.96,63.96 0 0 0 63.96,63.96l703.56,0a63.96,63.96 0 0 0 63.96,-63.96l0,-166.935l127.92,0a63.96,63.96 0 0 0 63.96,-63.96l0,-664.545a63.96,63.96 0 0 0 -63.96,-63.96zm-220.88,733.505l-1,195.89499l-639.55999,1l-1,-648.55999l640.55999,0l1,451.665zm205.322,-24l-115.362,0l3,-453.665a63.96,63.96 0 0 0 -63.96,-63.96l-449.624,-1l0,-108.92l626.50399,-1l-0.558,628.545z",
      "p-id": "5311",
      id: "svg_1",
      stroke: "null"
    }))), props.disableCloseBtn !== true && /*#__PURE__*/React.createElement("div", {
      className: "btn btn-del",
      onClick: onCloseWindow
    }, /*#__PURE__*/React.createElement(CloseOutlined, null)));
  } else {
    return /*#__PURE__*/React.createElement("div", null);
  }
};
export default ControlPanel;