function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
import "antd/es/tooltip/style";
import _Tooltip from "antd/es/tooltip";
import "antd/es/config-provider/style";
import _ConfigProvider from "antd/es/config-provider";
import "antd/es/pagination/style";
import _Pagination from "antd/es/pagination";
import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/divider/style";
import _Divider from "antd/es/divider";
import "antd/es/progress/style";
import _Progress from "antd/es/progress";
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/*
 * @Author: chenzenghua
 * @Date: 2023-02-14 00:06:29
 * @LastEditTime: 2024-01-29 23:54:40
 * @LastEditors: chenzenghua
 * @Description:
 */

import { AgGridReact } from 'ag-grid-react';
import React, { useCallback, useEffect, useImperativeHandle, useLayoutEffect, useMemo, useRef, useState } from 'react';
import { columnTypes, customAvgAggFunction, customMaxAggFunction, customMinAggFunction, customStaticGroupAggFunction, customSumAggFunction } from "./typing";
// import packageConfig from '../../package.json'
import { AlignLeftOutlined, ClearOutlined, ControlOutlined, FullscreenExitOutlined, FullscreenOutlined, UploadOutlined } from '@ant-design/icons';
import 'ag-grid-enterprise';
import { LicenseManager } from 'ag-grid-enterprise';
import { useDebounceFn, useFullscreen, useLatest, useSize, useThrottleFn, useUpdateEffect, useWhyDidYouUpdate } from 'ahooks';
import zhCN from 'antd/es/locale/zh_CN';
import { ceil, has, isEmpty, isFunction, omit, sumBy } from 'lodash';
import moment from 'moment';
import DateEditComponent from "./components/DateEditComponent";
import Loading from "./components/Loading";
import NumericEditor from "./components/NumbericEditComponent";
import noRowsOverlayComponent from "./components/noRowsOverlayComponent";
import { EXCEL_STYLES } from "./excelStyles";
import { AG_GRID_LOCALE_CN } from "./locale.cn";
import "./styles.less";
// import './styles/ag-grid.css' // Core grid CSS, always needed
// import './styles/ag-theme-balham.css' // Optional theme CSS

import { judgeCompareValue } from "../utils/innerFun";
import 'ag-grid-community/styles/ag-grid.css';
import 'ag-grid-community/styles/ag-theme-balham.css';
import { desensitive } from "../utils";
import CellEditRender from "./components/CellEditRender";
import SelectEditComponent from "./components/SelectEditComponent";
import SwitchEditComponent from "./components/SwitchEditComponent";
import TreeSelectEditComponent from "./components/TreeSelectEditComponent";
import "./styles/xtheme.css"; // Optional theme CSS

LicenseManager.setLicenseKey('MjAwMDAwMDAwMDAwMA==598447838c89eb4366146127615e40a4');
function XDataGrid(props, ref) {
  var _gridRef$current, _props$selectedRows, _gridRef$current22, _gridRef$current23, _gridRef$current24, _gridRef$current26, _gridRef$current27;
  var gridRef = useRef(null);
  var _useState = useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    changeflag = _useState2[0],
    setchangeflag = _useState2[1];
  var api = (_gridRef$current = gridRef.current) === null || _gridRef$current === void 0 ? void 0 : _gridRef$current.api;
  var wrapperRef = useRef(null);
  var size = useSize(wrapperRef);
  var _useFullscreen = useFullscreen(wrapperRef),
    _useFullscreen2 = _slicedToArray(_useFullscreen, 2),
    isFullscreen = _useFullscreen2[0],
    toggleFullscreen = _useFullscreen2[1].toggleFullscreen;
  var _useState3 = useState(),
    _useState4 = _slicedToArray(_useState3, 2),
    oldFocusRowID = _useState4[0],
    setoldFocusRowID = _useState4[1];
  var gridOptionsMegered = useMemo(function () {
    return _objectSpread(_objectSpread({}, props.gridConfigJson), props);
  }, [props]);
  var _useState5 = useState(),
    _useState6 = _slicedToArray(_useState5, 2),
    gridAPi = _useState6[0],
    setgridAPi = _useState6[1];
  //对外接口
  useImperativeHandle(ref, function () {
    var _gridRef$current2, _gridRef$current3;
    return {
      api: (_gridRef$current2 = gridRef.current) === null || _gridRef$current2 === void 0 ? void 0 : _gridRef$current2.api,
      columnApi: (_gridRef$current3 = gridRef.current) === null || _gridRef$current3 === void 0 ? void 0 : _gridRef$current3.columnApi,
      ExportToExcel: function ExportToExcel(options) {
        var _gridRef$current4;
        //合并单元格
        var mergeAcross = 0;
        if (options !== null && options !== void 0 && options.headContentCellMergeAcross) {
          mergeAcross = options.headContentCellMergeAcross;
        } else if (options !== null && options !== void 0 && options.columnKeys) {
          mergeAcross = options.columnKeys.length - 1;
        }
        if (options !== null && options !== void 0 && options.headContent) {
          options.prependContent = [{
            height: 60,
            cells: [{
              data: {
                value: options.headContent,
                type: 'String'
              },
              mergeAcross: mergeAcross,
              styleId: 'headcontent'
            }]
          }];
        }
        (_gridRef$current4 = gridRef.current) === null || _gridRef$current4 === void 0 || (_gridRef$current4 = _gridRef$current4.api) === null || _gridRef$current4 === void 0 || _gridRef$current4.exportDataAsExcel(_objectSpread({
          fileName: "\u5BFC\u51FA".concat(moment().format('_YYYYMMDDHHmmssSSS'), ".xlsx"),
          sheetName: 'Sheet1',
          headerRowHeight: 30
        }, options));
      },
      TurnToRowIndex: function TurnToRowIndex(number) {
        api === null || api === void 0 || api.ensureIndexVisible(number, 'middle');
        setTimeout(function () {
          // 闪烁一下
          var rowNode = api === null || api === void 0 ? void 0 : api.getDisplayedRowAtIndex(number);
          if (rowNode) {
            api === null || api === void 0 || api.flashCells({
              rowNodes: [rowNode],
              flashDelay: 2000,
              fadeDelay: 1000
            });
          }
        }, 200);
      },
      TurnToRowByRowID: function TurnToRowByRowID(value) {
        var rowNode = api === null || api === void 0 ? void 0 : api.getRowNode(value);
        api === null || api === void 0 || api.ensureNodeVisible(rowNode, 'middle');
        setTimeout(function () {
          // 闪烁一下
          if (rowNode) {
            api === null || api === void 0 || api.flashCells({
              rowNodes: [rowNode],
              flashDelay: 2000,
              fadeDelay: 1000
            });
          }
        }, 200);
      },
      GetSelectedRowInFilterRows: function GetSelectedRowInFilterRows() {
        var selectedrows = api === null || api === void 0 ? void 0 : api.getSelectedRows();
        var x = [];
        if (!props.rowID) {
          throw new Error('未指定列ID,无法执行该操作');
        } else {
          api === null || api === void 0 || api.forEachNodeAfterFilter(function (item) {
            //@ts-ignore
            if (selectedrows !== null && selectedrows !== void 0 && selectedrows.find(function (p) {
              return p[props.rowID] === item.data[props.rowID];
            })) {
              x.push(item.data);
            }
          });
          return x;
        }
      },
      ensureColumnVisible: function ensureColumnVisible(key, positon) {
        api === null || api === void 0 || api.ensureColumnVisible(key, positon);
      }
    };
  });
  // 记录最新的data数据
  var latestData = useLatest(props.data);
  var _useState7 = useState(props.paginationPageSize),
    _useState8 = _slicedToArray(_useState7, 2),
    pageSize = _useState8[0],
    setpageSize = _useState8[1];
  var _useState9 = useState(1),
    _useState10 = _slicedToArray(_useState9, 2),
    currPageIndex = _useState10[0],
    setcurrPageIndex = _useState10[1];
  var _useState11 = useState(0),
    _useState12 = _slicedToArray(_useState11, 2),
    rowcount = _useState12[0],
    setrowcount = _useState12[1];
  //#region 基本信息
  var _useState13 = useState(false),
    _useState14 = _slicedToArray(_useState13, 2),
    isMac = _useState14[0],
    setisMac = _useState14[1];
  var _useState15 = useState(999),
    _useState16 = _slicedToArray(_useState15, 2),
    chromeVersion = _useState16[0],
    setchromeVersion = _useState16[1];
  if (props.debug) {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    useWhyDidYouUpdate('[XDataGrid DBG:]', props);
  }
  useEffect(function () {
    var mac = function () {
      return /macintosh|mac os x/i.test(navigator.userAgent);
    }();
    setisMac(mac);
    if (mac) {
      console.log('%c [xinherc is run on mac]', 'background:#057ae3;color:#ffffff');
    }
  }, []);
  useEffect(function () {
    var re = new RegExp('Chrome/(.+?) ');
    var v = re.exec(navigator.appVersion);
    if (v) {
      var version = v[1];
      var chrome = Number(version.split('.')[0]);
      setchromeVersion(chrome);
      console.log('%c [Chrome Version:' + chrome + ']', 'background:#057ae3;color:#ffffff');
    }
  }, []);
  useEffect(function () {
    if (gridOptionsMegered.paginationPageSize) {
      setpageSize(gridOptionsMegered.paginationPageSize);
    }
  }, [gridOptionsMegered.paginationPageSize]);
  // 窗体大小变化时 自动调用列宽自适应
  var onResize = useThrottleFn(function () {
    if (gridOptionsMegered.autoFitWith) {
      var _gridRef$current5;
      (_gridRef$current5 = gridRef.current) === null || _gridRef$current5 === void 0 || (_gridRef$current5 = _gridRef$current5.api) === null || _gridRef$current5 === void 0 || _gridRef$current5.sizeColumnsToFit();
    }
  }, {
    wait: 300
  }).run;
  useUpdateEffect(function () {
    onResize();
  }, [size]);

  //#endregion

  var memoColDef = useMemo(function () {
    if (!props.columnDefs) {
      console.error('列配置未定义!');
      return [];
    }
    // 列前处理
    // 标记是否有二级表头
    //@ts-ignore
    //20230523 已通过spanHeaderHeight支持该功能,不再需要hack
    //let hasLeve2 = false

    var preCreateCol = function preCreateCol(colOrigin) {
      var arr = [];
      colOrigin === null || colOrigin === void 0 || colOrigin.forEach(function (item) {
        item.spanHeaderHeight = true;
        // 插入列额外配置
        if (item.valueGetterEnum && !item.valueGetter && item.field) {
          var enumCustom = item.valueGetterEnum;
          // valueGetter优先级高于valueGetterEnum
          item.valueGetter = function (p) {
            var _p$data;
            var v = (_p$data = p.data) === null || _p$data === void 0 ? void 0 : _p$data[item.field];
            if (v) {
              return has(enumCustom, v) ? enumCustom[v] : v;
            } else return undefined;
          };
          // 删除多余属性,防止报警
          item = omit(item, 'valueGetterEnum');
        }
        //如果定义值自动映射
        else if (item.valueGetterAutoMapper && item.valueGetterAutoMapper.dataName) {
          var _item$valueGetterAuto = item.valueGetterAutoMapper,
            dataName = _item$valueGetterAuto.dataName,
            _item$valueGetterAuto2 = _item$valueGetterAuto.mapField,
            mapField = _item$valueGetterAuto2 === void 0 ? 'id' : _item$valueGetterAuto2,
            _item$valueGetterAuto3 = _item$valueGetterAuto.textField,
            textField = _item$valueGetterAuto3 === void 0 ? 'name' : _item$valueGetterAuto3;
          //暂存基础数据
          var x = localStorage.getItem(dataName);
          if (!x) {
            console.log("XDataGrid:localStorage\u4E0D\u5B58\u5728\u540D\u4E3A(".concat(dataName, ")\u7684\u5B57\u5178\u6570\u636E"));
          } else {
            //优化性能,不要重复写入
            if (!window[dataName]) {
              //写入window
              var d = JSON.parse(x);
              window[dataName] = d;
              console.log('XDataGrid:基础数据写入window:' + dataName);
            }
          }

          //复写valueGetter
          item.valueGetter = function (p) {
            var value = p.data[item.field];
            if (value) {
              var _window$dataName;
              //@ts-ignore
              return ((_window$dataName = window[dataName]) === null || _window$dataName === void 0 || (_window$dataName = _window$dataName.find(function (p) {
                return p[mapField] === value;
              })) === null || _window$dataName === void 0 ? void 0 : _window$dataName[textField]) || value;
            } else return undefined;
          };
          item = omit(item, 'valueGetterAutoMapper');
        }
        //如果定义了比较方案
        if (item.comparator && typeof item.comparator === 'string') {
          switch (item.comparator) {
            case '首字母':
              item.comparator = function (a, b) {
                var sort = 0;
                if (!a && b) {
                  sort = 2;
                }
                if (a && !b) {
                  sort = -2;
                }
                sort = a.localeCompare(b, 'pinyin');
                return sort;
              };
              break;
            case '数字':
              item.comparator = function (a, b) {
                if (!a || !b) {
                  return -1;
                } else {
                  var a1 = Number(a);
                  var b1 = Number(b);
                  return a1 > b1 ? '1' : -1;
                }
              };
              break;
            default:
              item.comparator = function (a, b) {
                return a.localeCompare(b);
              };
              break;
          }
        }
        //如果定义了自动脱敏
        if (item.desensitiveType) {
          item.valueGetter = function (p) {
            var _p$data2;
            var v = (_p$data2 = p.data) === null || _p$data2 === void 0 ? void 0 : _p$data2[item.field];
            var desentiveValue = desensitive(item.desensitiveType, v);
            //脱敏
            return desentiveValue;
          };
        }

        // 合计列样式
        item.cellRendererSelector = function (params) {
          if (params.node.rowPinned) {
            return {
              component: 'CustomPinnedRow'
            };
          }
          return undefined;
        };
        if (item.children) {
          item.children = preCreateCol(item.children);
          //hasLeve2 = true
        }
        //cellRendererFramework=>cellRenderer cellRendererFramework弃用
        if (item.cellRendererFramework) {
          item.cellRenderer = item.cellRendererFramework;
          item = omit(item, 'cellRendererFramework');
        }
        if (item.cellRenderer && typeof item.cellRenderer === 'string') {
          //按名称渲染内置组件
          switch (item.cellRenderer) {
            case 'progress':
              {
                item.cellRenderer = function (_ref) {
                  var value = _ref.value;
                  return /*#__PURE__*/React.createElement(_Progress, {
                    percent: value,
                    size: "small"
                  });
                };
              }
          }
        }
        arr.push(item);
        if (gridOptionsMegered.editAllRow && (item.cellEditor || item.editable)) {
          item.cellRenderer = function (params) {
            return /*#__PURE__*/React.createElement(CellEditRender, {
              colDef: item,
              cellEvent: params
            });
          };
          // 可能某些情况需要禁用键盘事件
          // item.suppressKeyboardEvent = () => true
        } else {
          //编辑器转换
          if (item.cellEditor) {
            switch (item.cellEditor) {
              case 'extNumericEditor':
                item.cellEditor = NumericEditor;
                break;
              case 'extDateEditor':
                item.cellEditor = DateEditComponent;
                break;
              case 'extSelectEditor':
                item.cellEditor = SelectEditComponent;
                break;
              case 'extSwitchEditor':
                item.cellEditor = SwitchEditComponent;
                break;
              case 'extTreeSelectEditor':
                item.cellEditor = TreeSelectEditComponent;
                break;
              //todo:其他编辑器,待扩展
              //1.antd下拉选择器,单选/多选
              //2.开关
              default:
                break;
            }
          }
        }

        //按单元格值及判定条件渲染单元格
        if (item.predicateCellRender) {
          var defaultCellStyle = item.cellStyle || undefined;
          item.cellStyle = function (p) {
            var _item$predicateCellRe;
            if (isEmpty(p === null || p === void 0 ? void 0 : p.data)) {
              return;
            }
            var cellStyle = {};
            (_item$predicateCellRe = item.predicateCellRender) === null || _item$predicateCellRe === void 0 || (_item$predicateCellRe = _item$predicateCellRe.rules) === null || _item$predicateCellRe === void 0 || _item$predicateCellRe.forEach(function (rule) {
              var value = p.value;
              if (rule.field) {
                // 是否有自定义映射字段值
                value = item.rulesFieldkey ? p.data[item.rulesFieldkey] : p.data[rule.field];
              }
              if (['', null].includes(value)) {
                return;
              }
              var res = judgeCompareValue(value, rule.value, rule.opt, rule.compareType);
              if (res === true) {
                cellStyle = rule.cellStyle;
              }
            });
            if (!isEmpty(cellStyle)) {
              return cellStyle;
            } else {
              if (isFunction(defaultCellStyle)) {
                return defaultCellStyle(p);
              } else {
                return defaultCellStyle;
              }
            }
          };
        }
        if (item.children) {
          item.children = preCreateCol(item.children);
        }
      });
      return arr;
    };
    var cols = preCreateCol(_toConsumableArray(props.columnDefs));
    var noColWidth = 30;
    if (rowcount > 99) {
      noColWidth = 35;
    }
    if (rowcount > 999) {
      noColWidth = 40;
    }
    if (rowcount > 9999) {
      noColWidth = 45;
    }
    var def = [
    // 序号列
    {
      width: noColWidth,
      minWidth: noColWidth,
      maxWidth: 60,
      //@ts-ignore
      spanHeaderHeight: true,
      resizable: true,
      suppressMovable: true,
      pinned: 'left',
      lockPinned: true,
      lockPosition: 'left',
      field: '_NO_ROW',
      headerName: 'No.',
      filter: false,
      valueGetter: function valueGetter(e) {
        if (e.node.rowPinned) {
          return '∑';
        }
        return e.node.rowIndex + 1;
      },
      cellStyle: _objectSpread({
        fontSize: '10px',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center'
      }, gridOptionsMegered.numberColCellStyle),
      cellClass: 'x-data-grid-rownumber-col-cell',
      hide: !gridOptionsMegered.showRowNumberCol,
      suppressMenu: true,
      suppressSizeToFit: true
    },
    // 选中列
    {
      width: 30,
      minWidth: 30,
      maxWidth: 30,
      resizable: false,
      //@ts-ignore
      spanHeaderHeight: true,
      suppressMovable: true,
      field: '_CHECK_ROW',
      filter: false,
      pinned: props.pinSelectionCol || undefined,
      headerName: '',
      headerCheckboxSelection: props.rowSelection === 'multiple',
      suppressColumnsToolPanel: true,
      cellStyle: {
        textAlign: 'center',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        color: '#00b0ff'
      },
      cellClass: 'x-data-grid-select-col-cell',
      checkboxSelection: function checkboxSelection(p) {
        if (p.node.group) {
          return false;
        } else return true;
      },
      headerCheckboxSelectionFilteredOnly: true,
      hide: !gridOptionsMegered.showSelectionCol,
      suppressMenu: true,
      suppressFiltersToolPanel: true
    }].concat(_toConsumableArray(cols));
    return def;
  }, [props.editAllRow, props.columnDefs, props.pinSelectionCol, props.rowSelection, props.keepFilerStateOnDataRefresh, gridOptionsMegered.numberColCellStyle, gridOptionsMegered.showRowNumberCol, gridOptionsMegered.showSelectionCol]);

  //聚焦行 等待数据加载完再执行
  useLayoutEffect(function () {
    var ignore = false;
    if (gridOptionsMegered.autoFitWith) {
      var _gridRef$current6;
      (_gridRef$current6 = gridRef.current) === null || _gridRef$current6 === void 0 || (_gridRef$current6 = _gridRef$current6.api) === null || _gridRef$current6 === void 0 || _gridRef$current6.sizeColumnsToFit();
    }
    try {
      var _gridRef$current11, _gridRef$current12;
      if (!props.focusRowId || gridOptionsMegered.suppressFocusRow || !props.rowID) {
        if (oldFocusRowID) {
          var _gridRef$current7, _gridRef$current8;
          var oldRowNode = (_gridRef$current7 = gridRef.current) === null || _gridRef$current7 === void 0 || (_gridRef$current7 = _gridRef$current7.api) === null || _gridRef$current7 === void 0 ? void 0 : _gridRef$current7.getRowNode(oldFocusRowID);
          (_gridRef$current8 = gridRef.current) === null || _gridRef$current8 === void 0 || (_gridRef$current8 = _gridRef$current8.api) === null || _gridRef$current8 === void 0 || _gridRef$current8.setGetRowClass(function (params) {
            var _props$focusRowId;
            if (params.node.id.toString() === ((_props$focusRowId = props.focusRowId) === null || _props$focusRowId === void 0 ? void 0 : _props$focusRowId.toString())) {
              return 'focus-row';
            }
            return '';
          });
          if (oldRowNode) {
            if (props.optimizeFocus) {
              if (!ignore) {
                var _gridRef$current9;
                (_gridRef$current9 = gridRef.current) === null || _gridRef$current9 === void 0 || (_gridRef$current9 = _gridRef$current9.api) === null || _gridRef$current9 === void 0 || _gridRef$current9.redrawRows({
                  rowNodes: [oldRowNode]
                });
              }
            } else {
              setTimeout(function () {
                if (!ignore) {
                  var _gridRef$current10;
                  (_gridRef$current10 = gridRef.current) === null || _gridRef$current10 === void 0 || (_gridRef$current10 = _gridRef$current10.api) === null || _gridRef$current10 === void 0 || _gridRef$current10.redrawRows({
                    rowNodes: [oldRowNode]
                  });
                }
              }, 0);
            }
          }
        }
        return;
      }
      var rowNode = (_gridRef$current11 = gridRef.current) === null || _gridRef$current11 === void 0 || (_gridRef$current11 = _gridRef$current11.api) === null || _gridRef$current11 === void 0 ? void 0 : _gridRef$current11.getRowNode(props.focusRowId);
      (_gridRef$current12 = gridRef.current) === null || _gridRef$current12 === void 0 || (_gridRef$current12 = _gridRef$current12.api) === null || _gridRef$current12 === void 0 || _gridRef$current12.setGetRowClass(function (params) {
        var _props$focusRowId2;
        if (params.node.id.toString() === ((_props$focusRowId2 = props.focusRowId) === null || _props$focusRowId2 === void 0 ? void 0 : _props$focusRowId2.toString())) {
          return 'focus-row';
        }
        return '';
      });
      if (oldFocusRowID) {
        var _gridRef$current13;
        var _oldRowNode = (_gridRef$current13 = gridRef.current) === null || _gridRef$current13 === void 0 || (_gridRef$current13 = _gridRef$current13.api) === null || _gridRef$current13 === void 0 ? void 0 : _gridRef$current13.getRowNode(oldFocusRowID);
        if (_oldRowNode) {
          if (props.optimizeFocus) {
            if (!ignore) {
              var _gridRef$current14;
              (_gridRef$current14 = gridRef.current) === null || _gridRef$current14 === void 0 || (_gridRef$current14 = _gridRef$current14.api) === null || _gridRef$current14 === void 0 || _gridRef$current14.redrawRows({
                rowNodes: [_oldRowNode]
              });
            }
          } else {
            setTimeout(function () {
              if (!ignore) {
                var _gridRef$current15;
                (_gridRef$current15 = gridRef.current) === null || _gridRef$current15 === void 0 || (_gridRef$current15 = _gridRef$current15.api) === null || _gridRef$current15 === void 0 || _gridRef$current15.redrawRows({
                  rowNodes: [_oldRowNode]
                });
              }
            }, 0);
          }
        }
      }
      if (rowNode) {
        setTimeout(function () {
          if (!ignore) {
            var _gridRef$current16;
            (_gridRef$current16 = gridRef.current) === null || _gridRef$current16 === void 0 || (_gridRef$current16 = _gridRef$current16.api) === null || _gridRef$current16 === void 0 || _gridRef$current16.redrawRows({
              rowNodes: [rowNode]
            });
          }
        }, 0);
      }
      setoldFocusRowID(props.focusRowId);
    } catch (error) {
      console.log(error);
    }
    return function () {
      ignore = true;
    };
  }, [props.focusRowId, props.data, props.columnDefs, gridOptionsMegered.suppressFocusRow, gridOptionsMegered.autoFitWith]);

  //边栏
  useEffect(function () {
    if (gridOptionsMegered.sideBar) {
      api === null || api === void 0 || api.setSideBar({
        toolPanels: [{
          id: 'columns',
          labelDefault: 'Columns',
          labelKey: 'columns',
          iconKey: 'columns',
          toolPanel: 'agColumnsToolPanel',
          toolPanelParams: {
            //suppressRowGroups: true,
            //suppressValues: true,
            suppressPivots: true
            //suppressPivotMode: true,
            //suppressColumnFilter: true,
            //suppressColumnSelectAll: true,
            //suppressColumnExpandAll: true,
          }
        }, {
          id: 'filters',
          labelDefault: 'Filters',
          labelKey: 'filters',
          iconKey: 'filter',
          toolPanel: 'agFiltersToolPanel',
          width: 200
        }]
      });
    } else {
      api === null || api === void 0 || api.setSideBarVisible(false);
    }
  }, [gridOptionsMegered.sideBar]);

  // 更新数据 数据变更时触发
  useLayoutEffect(function () {
    if (!api) {
      return;
    }
    if (!props.data || props.data.length === 0) {
      setrowcount(0);
    }
    var ignore = false;
    //解决 无关组件 空数据闪烁问题
    if (props.data && props.data.length == 0 || !props.data) {
      var _api$getRenderedNodes;
      var currLen = (api === null || api === void 0 || (_api$getRenderedNodes = api.getRenderedNodes()) === null || _api$getRenderedNodes === void 0 ? void 0 : _api$getRenderedNodes.length) || 0;
      if (currLen > 0) {
        api === null || api === void 0 || api.setRowData([]);
      }
    } else if (props.data && gridRef.current) {
      try {
        var _props$data;
        // setTimeout(() => {
        //   if (!ignore) {
        //     api?.setRowData(props.data)
        //     setrowcount(props.data?.length || 0)
        //   }
        // }, 0)
        api === null || api === void 0 || api.setRowData(props.data);
        setrowcount(((_props$data = props.data) === null || _props$data === void 0 ? void 0 : _props$data.length) || 0);
      } catch (error) {
        console.log(error);
      }
    }
    return function () {
      ignore = true;
    };
  }, [props.data, gridRef, gridOptionsMegered, api]);

  // 选中行
  useLayoutEffect(function () {
    if (props.selectedRows && gridRef.current && gridOptionsMegered.rowID) {
      if (!props.rowID) {
        console.log('未指定RowId');
      } else {
        try {
          gridAPi === null || gridAPi === void 0 || gridAPi.forEachNode(function (node) {
            //@ts-ignore
            var x = props.selectedRows.find(function (p) {
              var _node$data;
              return p[props.rowID] === ((_node$data = node.data) === null || _node$data === void 0 ? void 0 : _node$data[props.rowID]);
            });
            if (x) {
              node.setSelected(true);
            } else {
              node.setSelected(false);
            }
          });
        } catch (error) {
          console.log(error);
        }
      }
    }
  }, [props.selectedRows, props.data, gridRef, gridOptionsMegered.rowID, gridAPi]);

  //自动框选防抖
  var debounceAutoRangeSelect = useDebounceFn(function (e) {
    var _e$api;
    var cellRanges = (_e$api = e.api) === null || _e$api === void 0 ? void 0 : _e$api.getCellRanges();
    cellRanges === null || cellRanges === void 0 || cellRanges.forEach(function (range) {
      // @ts-ignore
      var startRow = Math.min(range.startRow.rowIndex, range.endRow.rowIndex);
      // @ts-ignore
      var endRow = Math.max(range.startRow.rowIndex, range.endRow.rowIndex);
      if (startRow === endRow) {
        return;
      }
      var _loop = function _loop(rowIndex) {
        range.columns.forEach(function () {
          var rowModel = e.api.getModel();
          var rowNode = rowModel.getRow(rowIndex);
          rowNode === null || rowNode === void 0 || rowNode.setSelected(true);
        });
      };
      for (var rowIndex = startRow; rowIndex <= endRow; rowIndex += 1) {
        _loop(rowIndex);
      }
    });
  }, {
    wait: 50
  });
  //防抖
  var debounceRangeChanged = useDebounceFn(function (e) {
    var _gridOptionsMegered$a;
    !e.started && e.finished && ((_gridOptionsMegered$a = gridOptionsMegered.afterRangeSelection) === null || _gridOptionsMegered$a === void 0 ? void 0 : _gridOptionsMegered$a.call(gridOptionsMegered, e));
  }, {
    wait: 50
  });
  var staticGroupAgg = useCallback(function (p) {
    return customStaticGroupAggFunction(p, props.dataGroupStatic);
  }, [props.dataGroupStatic]);
  var AgGridComponents = useCallback(function () {
    var option = _objectSpread({
      //getRowClass: getRowClass,
      //默认列配置
      defaultColDef: _objectSpread({
        // allow every column to be aggregated
        // enableValue: true,
        // // allow every column to be grouped
        // enableRowGroup: true,
        // // allow every column to be pivoted
        // enablePivot: true,
        cellDataType: false,
        resizable: true,
        filter: true,
        filterParams: {
          excelMode: 'windows',
          newRowsAction: props.keepFilerStateOnDataRefresh === true ? 'keep' : '',
          buttons: ['reset', 'apply'],
          debounceMs: 200,
          closeOnApply: true,
          trimInput: true
        },
        menuTabs: ['filterMenuTab', 'generalMenuTab']
      }, gridOptionsMegered.defaultColDef || {}),
      suppressAggFuncInHeader: true,
      //groupHideOpenParents: true,
      autoGroupColumnDef: {
        filter: true,
        sortable: true,
        //@ts-ignore
        spanHeaderHeight: true,
        cellStyle: {
          display: 'flex',
          alignItems: 'center',
          justifyContent: 'flex-start',
          fontWeight: 550
        },
        //   headerName: '分组归类',

        cellRendererParams: {
          // innerRenderer: (e) => null,
          suppressCount: true,
          footerValueGetter: function footerValueGetter(params) {
            var rootLevel = params.node.level;
            if (rootLevel === -1) {
              return "\u5408\u8BA1";
            } else {
              return "\u5C0F\u8BA1(".concat(params.value, ")");
            }
          }
        }
      },
      //分组默认展开层级
      groupDefaultExpanded: gridOptionsMegered.groupDefaultExpanded,
      groupIncludeFooter: gridOptionsMegered.groupIncludeFooter,
      groupIncludeTotalFooter: gridOptionsMegered.groupIncludeTotalFooter,
      statusBar: gridOptionsMegered.enableRangeSelection && gridOptionsMegered.autoAggSelectRowInStateBar ? {
        statusPanels: [{
          statusPanel: 'agAggregationComponent',
          statusPanelParams: {
            // possible values are: 'count', 'sum', 'min', 'max', 'avg'
            aggFuncs: ['sum', 'avg', 'min', 'max']
          }
        }]
      } : undefined,
      getContextMenuItems: function getContextMenuItems() {
        return ['copy', 'copyWithHeaders', {
          name: '导出EXCEL',
          action: function action() {
            if (props.inlineExportFunc) {
              var _gridRef$current17;
              props.inlineExportFunc((_gridRef$current17 = gridRef.current) === null || _gridRef$current17 === void 0 ? void 0 : _gridRef$current17.api);
            } else {
              var _gridRef$current18;
              //export
              var op = {
                fileName: "\u6570\u636E\u5BFC\u51FA.xlsx",
                sheetName: 'Sheet1',
                headerRowHeight: 30,
                processRowGroupCallback: function processRowGroupCallback(params) {
                  return "\u6C47\u603B(".concat(params.node.key, ") ");
                }
              };
              (_gridRef$current18 = gridRef.current) === null || _gridRef$current18 === void 0 || (_gridRef$current18 = _gridRef$current18.api) === null || _gridRef$current18 === void 0 || _gridRef$current18.exportDataAsExcel(_objectSpread({}, op));
            }
          }
        }, {
          name: '导出CSV',
          action: function action() {
            if (props.inlineCsvExportFunc) {
              var _gridRef$current19;
              props.inlineCsvExportFunc((_gridRef$current19 = gridRef.current) === null || _gridRef$current19 === void 0 ? void 0 : _gridRef$current19.api);
            } else {
              var _gridRef$current20;
              //CSV
              var op = {
                fileName: "\u6570\u636E\u5BFC\u51FA.csv"
              };
              (_gridRef$current20 = gridRef.current) === null || _gridRef$current20 === void 0 || (_gridRef$current20 = _gridRef$current20.api) === null || _gridRef$current20 === void 0 || _gridRef$current20.exportDataAsCsv(_objectSpread({}, op));
            }
          }
        }, 'autoSizeAll', 'resetColumns'];
      },
      singleClickEdit: gridOptionsMegered.singleClickEdit,
      //预读行数
      rowBuffer: 20,
      //禁止拖动移除列
      suppressDragLeaveHidesColumns: true,
      suppressMenuHide: true,
      scrollbarWidth: gridOptionsMegered.useNativeScrollBar ? undefined : 9,
      //suppressCellFocus: true,
      //允许范围框选
      enableRangeSelection: gridOptionsMegered.enableRangeSelection,
      enableRangeHandle: gridOptionsMegered.enableRangeSelection,
      //分页相关
      pagination: gridOptionsMegered.pagination,
      paginationPageSize: gridOptionsMegered.paginationPageSize || 50,
      //空状态参数
      noRowsOverlayComponentParams: {
        children: gridOptionsMegered.noRowComponent,
        noRowText: gridOptionsMegered.noRowText
      },
      debounceVerticalScrollbar: gridOptionsMegered.debounceVerticalScrollbar,
      //行选
      rowSelection: gridOptionsMegered.rowSelection,
      // 忽略行点击选中,只能由复选框选中
      suppressRowClickSelection: gridOptionsMegered.suppressRowClickSelection,
      // 行选中事件
      onSelectionChanged: function onSelectionChanged(p) {
        var _gridOptionsMegered$o;
        (_gridOptionsMegered$o = gridOptionsMegered.onSelectionChanged) === null || _gridOptionsMegered$o === void 0 || _gridOptionsMegered$o.call(gridOptionsMegered, p.api.getSelectedRows(), p.api);
      },
      onRowDoubleClicked: gridOptionsMegered.onRowDoubleClicked,
      onRowClicked: function onRowClicked(e) {
        var _e$event, _e$event2, _e$event3, _e$event4, _gridOptionsMegered$o3;
        var eventTag =
        //@ts-ignore

        typeof ((_e$event = e.event) === null || _e$event === void 0 || (_e$event = _e$event.target) === null || _e$event === void 0 ? void 0 : _e$event.tagName) === 'string' && ((_e$event2 = e.event) === null || _e$event2 === void 0 || (_e$event2 = _e$event2.target) === null || _e$event2 === void 0 || (_e$event2 = _e$event2.tagName) === null || _e$event2 === void 0 ? void 0 : _e$event2.toLowerCase()) || '';
        var eventClassName =
        //@ts-ignore
        typeof ((_e$event3 = e.event) === null || _e$event3 === void 0 || (_e$event3 = _e$event3.target) === null || _e$event3 === void 0 ? void 0 : _e$event3.className) === 'string' && ((_e$event4 = e.event) === null || _e$event4 === void 0 || (_e$event4 = _e$event4.target) === null || _e$event4 === void 0 || (_e$event4 = _e$event4.className) === null || _e$event4 === void 0 ? void 0 : _e$event4.toLowerCase()) || '';
        if (['input', 'button', 'select', 'textarea'].includes(eventTag) || (eventClassName === null || eventClassName === void 0 ? void 0 : eventClassName.indexOf('-color-picker')) > 0) {
          //忽略表单项的点击事件
          return;
        }
        if (!e.node.rowPinned && !gridOptionsMegered.suppressFocusRow) {
          var _gridOptionsMegered$o2;
          (_gridOptionsMegered$o2 = gridOptionsMegered.onRowFocued) === null || _gridOptionsMegered$o2 === void 0 || _gridOptionsMegered$o2.call(gridOptionsMegered, e.node.id, e);
        }
        (_gridOptionsMegered$o3 = gridOptionsMegered.onRowClicked) === null || _gridOptionsMegered$o3 === void 0 || _gridOptionsMegered$o3.call(gridOptionsMegered, e);
      },
      rowGroupPanelShow: gridOptionsMegered.allowRowGroup ? 'always' : undefined,
      rowMultiSelectWithClick: gridOptionsMegered.rowSelection === 'multiple',
      //编辑
      suppressClickEdit: !gridOptionsMegered.editable,
      onCellEditingStopped: gridOptionsMegered.onCellEditingStopped,
      onRowEditingStopped: gridOptionsMegered.onRowEditingStopped,
      editType: gridOptionsMegered.editType === 'fullRow' ? 'fullRow' : undefined,
      onRowValueChanged: gridOptionsMegered.onRowValueChanged,
      onCellValueChanged: gridOptionsMegered.onCellValueChanged,
      groupDisplayType: gridOptionsMegered.groupDisplayType,
      groupRowsSticky: !gridOptionsMegered.pagination,
      suppressRowTransform: gridOptionsMegered.suppressRowTransform
    }, gridOptionsMegered.gridOptions);
    //全表编辑增加单元格监听事件
    if (gridOptionsMegered.editAllRow) {
      option.onCellKeyDown = function (e) {
        // let { event } = e
        // if (['ArrowDown', 'ArrowUp'].includes(event?.key)) {
        var focuseCell = e.api.getFocusedCell();
        //@ts-ignore
        var _focuseCell$rowIndex = focuseCell.rowIndex,
          rowIndex = _focuseCell$rowIndex === void 0 ? 0 : _focuseCell$rowIndex,
          column = focuseCell.column;
        var _column$colDef = column.colDef,
          field = _column$colDef.field,
          cellEditor = _column$colDef.cellEditor;
        var key = "".concat(rowIndex, "_").concat(field);
        var thisInput = document.querySelector("[data-key=\"".concat(key, "\"]"));
        if (thisInput) {
          if (thisInput.nodeName === 'DIV') {
            thisInput = thisInput.querySelector('input');
          }
          if (!['extDateEditor', 'extSelectEditor', 'extTreeSelectEditor'].includes(cellEditor)) {
            var _thisInput;
            //@ts-ignore
            (_thisInput = thisInput) === null || _thisInput === void 0 || _thisInput.focus();
          }
        }
        // }
        if (!e.event) {
          return;
        }
      };
    }
    if (gridOptionsMegered.rowID) {
      //@ts-ignore
      option.getRowId = function (p) {
        return p.data[gridOptionsMegered.rowID];
      };
    }
    if (gridOptionsMegered.hideHead) {
      option.headerHeight = gridOptionsMegered.hideHead ? 0 : undefined;
    }
    if (props.debug) {
      console.log('options:');
      console.log(option);
    }
    return /*#__PURE__*/React.createElement(AgGridReact, {
      onRowDataUpdated: function onRowDataUpdated(e) {
        if (gridOptionsMegered.autoFitWith) {
          var _gridRef$current21;
          (_gridRef$current21 = gridRef.current) === null || _gridRef$current21 === void 0 || (_gridRef$current21 = _gridRef$current21.api) === null || _gridRef$current21 === void 0 || _gridRef$current21.sizeColumnsToFit();
        }
        if (!!gridOptionsMegered.showRowNumberCol) {
          e.api.refreshCells({
            columns: ['_NO_ROW']
          });
        }
      }
      // 行样式
      // @ts-ignore
      ,
      getRowStyle: function getRowStyle(p) {
        if (gridOptionsMegered.getRowStyle) {
          return gridOptionsMegered.getRowStyle(p);
        }
        if (gridOptionsMegered.rowStyleEnum && p.data) {
          var style = {};
          gridOptionsMegered.rowStyleEnum.forEach(function (item) {
            if (p.data[item.field] === item.value) {
              style = item.styles;
            }
          });
          return style;
        }
        return undefined;
      }
      //编辑
      // 多列排序快捷键
      ,
      multiSortKey: "ctrl"
      //rowData={props.data}
      // @ts-ignore：自定义类型覆盖
      ,
      ref: gridRef
      // @ts-ignore：自定义类型覆盖
      ,
      columnDefs: memoColDef
      //suppressReactUi={true}
      ,
      aggFuncs: {
        //覆盖均值方法,加入精度
        avg: customAvgAggFunction,
        sum: customSumAggFunction,
        min: customMinAggFunction,
        max: customMaxAggFunction,
        static: staticGroupAgg,
        none: function none() {
          return '-';
        }
      },
      rowHeight: gridOptionsMegered.rowHeight || undefined,
      columnTypes: columnTypes,
      suppressLoadingOverlay: true,
      suppressPropertyNamesCheck: true,
      rowDragManaged: true,
      groupSelectsFiltered: true
      //onGridColumnsChanged={(e) => console.log(e)}
      //suppressAggFuncInHeader={true}
      ,
      tooltipMouseTrack: true,
      tooltipShowDelay: 100,
      localeText: AG_GRID_LOCALE_CN,
      noRowsOverlayComponent: noRowsOverlayComponent
      //行双击事件
      ,
      onRowDoubleClicked: gridOptionsMegered.onRowDoubleClicked,
      onPaginationChanged: function onPaginationChanged(e) {
        return setcurrPageIndex(e.api.paginationGetCurrentPage() + 1);
      },
      excelStyles: [].concat(_toConsumableArray(EXCEL_STYLES), _toConsumableArray(gridOptionsMegered.excelStyles || [])),
      onGridReady: function onGridReady(p) {
        var _props$onGridReady;
        setgridAPi(p.api);
        //没有反向方法,所以写在这里
        if (gridOptionsMegered.autoFitWith) {
          p.api.sizeColumnsToFit();
        }
        setchangeflag(changeflag + 1);
        if (latestData.current) {
          p.api.setRowData(latestData.current);
        }
        (_props$onGridReady = props.onGridReady) === null || _props$onGridReady === void 0 || _props$onGridReady.call(props, p.api, p.columnApi);
      },
      onFilterChanged: function onFilterChanged(p) {
        var _gridOptionsMegered$o4;
        setrowcount(p.api.getDisplayedRowCount());
        p.api.refreshCells();
        (_gridOptionsMegered$o4 = gridOptionsMegered.onFilterChanged) === null || _gridOptionsMegered$o4 === void 0 || _gridOptionsMegered$o4.call(gridOptionsMegered, p);
      },
      onRangeSelectionChanged: function onRangeSelectionChanged(e) {
        debounceRangeChanged.run(e);
        if (gridOptionsMegered.rowSelection && gridOptionsMegered.rowSelection === 'multiple' && gridOptionsMegered.autoSelectRangeRow) {
          //自动框选
          debounceAutoRangeSelect.run(e);
        }
      }
      //不要内置分页器
      ,
      suppressPaginationPanel: true,
      gridOptions: option,
      stopEditingWhenCellsLoseFocus: option.editType === 'fullRow' || gridOptionsMegered.stopEditingWhenCellsLoseFocus === false ? false : true
    });
  },
  //存放变更后需要重新渲染的属性
  // eslint-disable-next-line react-hooks/exhaustive-deps
  [gridOptionsMegered.pagination, gridOptionsMegered.autoFitWith, gridOptionsMegered.enableRangeSelection, gridOptionsMegered.useNativeScrollBar, gridOptionsMegered.suppressRowClickSelection, gridOptionsMegered.rowSelection, gridOptionsMegered.debug, gridOptionsMegered.allowRowGroup, memoColDef, gridOptionsMegered.groupDefaultExpanded, gridOptionsMegered.editType, gridOptionsMegered.singleClickEdit, gridOptionsMegered.suppressFocusRow, gridOptionsMegered.autoSelectRangeRow, gridOptionsMegered.groupIncludeFooter, gridOptionsMegered.groupIncludeTotalFooter,
  //gridOptionsMegered.sideBar,
  gridOptionsMegered.groupDisplayType, gridOptionsMegered.paginationPageSize,
  //props.data,
  gridOptionsMegered.hideHead, gridOptionsMegered.rowHeight, gridOptionsMegered.editable, staticGroupAgg]);

  //组织样式类
  var className = useMemo(function () {
    var c = ' ';
    if (gridOptionsMegered.theme == 'dark') {
      c += ' ag-theme-balham-dark ';
    } else if (gridOptionsMegered.theme == 'fresh') {
      c += ' ag-theme-balham ag-theme-balham-fresh ';
    } else {
      c += ' ag-theme-balham ';
    }
    // !isMac &&
    if (!gridOptionsMegered.useNativeScrollBar) {
      if (gridOptionsMegered.theme === 'dark') {
        c += ' customScrollBarDark ';
      } else {
        c += ' customScrollBar ';
      }
    }
    if (gridOptionsMegered.noBorderRadius) {
      c += ' noBorderRadius ';
    }
    if (gridOptionsMegered.title) {
      c += ' hastitle ';
    }
    if (gridOptionsMegered.rowSelection === 'single') {
      c += ' singleselection ';
    }
    if (gridOptionsMegered.autoFitWith) {
      c += ' no-right-boder ';
    }
    if (gridOptionsMegered.hideHead) {
      c += ' no-head ';
    }
    return c;
  }, [gridOptionsMegered.theme, gridOptionsMegered.useNativeScrollBar, gridOptionsMegered.noBorderRadius, gridOptionsMegered.title, isMac, gridOptionsMegered.rowSelection, gridOptionsMegered.autoFitWith, gridOptionsMegered.hideHead]);
  // 自动合计行
  useEffect(function () {
    var rowCount = api === null || api === void 0 ? void 0 : api.getDisplayedRowCount();
    if (gridOptionsMegered.autoGenSummayRow && rowCount && rowCount > 0) {
      var arrFilter = [];
      for (var i = 0; i < rowCount; i += 1) {
        var rowNode = api === null || api === void 0 ? void 0 : api.getDisplayedRowAtIndex(i);
        if (rowNode !== null && rowNode !== void 0 && rowNode.group) {
          //跳过
          continue;
        }
        arrFilter.push(rowNode === null || rowNode === void 0 ? void 0 : rowNode.data);
      }
      var pinnedRow = [];
      var obj = {};
      gridOptionsMegered.autoGenSummayRow.forEach(function (item) {
        var s = sumBy(arrFilter, function (p) {
          var x = Number.parseFloat(p[item]);
          return Number.isNaN(x) ? 0 : x;
        });
        obj[item] = ceil(s, 2).toString();
      });
      pinnedRow.push(obj);
      gridAPi === null || gridAPi === void 0 || gridAPi.setPinnedBottomRowData(pinnedRow);
    } else {
      gridAPi === null || gridAPi === void 0 || gridAPi.setPinnedBottomRowData([]);
    }
  }, [gridOptionsMegered.autoGenSummayRow, gridAPi === null || gridAPi === void 0 ? void 0 : gridAPi.getDisplayedRowCount(), gridAPi]);

  // 低版本不支持flex，计算高度
  var gridHeight = 0;
  if (gridOptionsMegered.title) {
    gridHeight = 30;
  }
  if (!gridOptionsMegered.hideStatusBar && !props.disabled || gridOptionsMegered.hideStatusBar && gridOptionsMegered.StatusBarExtra) {
    gridHeight += 32;
  }
  return /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid ".concat(chromeVersion < 60 && 'chrome-49')
  }, /*#__PURE__*/React.createElement("div", {
    ref: wrapperRef,
    className: className,
    style: {
      height: '100%',
      width: '100%'
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(gridOptionsMegered.hideZebraStripe ? 'hideZebraStripe' : '', " gridWrapper")
  }, gridOptionsMegered.title && /*#__PURE__*/React.createElement("div", {
    className: "title ".concat(gridOptionsMegered.theme === 'dark' ? 'title-dark' : '')
  }, gridOptionsMegered.title), /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-contents",
    style: {
      height: "calc(100% - ".concat(gridHeight, "px)")
    }
  }, props.loading && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-loading"
  }, /*#__PURE__*/React.createElement(Loading, null)), /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-mask"
  }, /*#__PURE__*/React.createElement(Loading, null))), props.disabled && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-disabled"
  }), /*#__PURE__*/React.createElement("div", {
    className: "x-data-grid-mask-disabled"
  })), /*#__PURE__*/React.createElement(AgGridComponents, null)), props.data && !gridOptionsMegered.hideStatusBar && !props.disabled && /*#__PURE__*/React.createElement("div", {
    className: "".concat(gridOptionsMegered.theme === 'dark' ? 'pagination-bar-dark' : 'pagination-bar')
  }, /*#__PURE__*/React.createElement("div", {
    className: "total"
  }, props.loading ? 'loading...' : /*#__PURE__*/React.createElement(React.Fragment, null, !gridOptionsMegered.noRecordCountInStatuBar && /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(AlignLeftOutlined, {
    style: {
      marginRight: '4px'
    }
  }), " ", rowcount, " \u6761\u8BB0\u5F55"), props.selectedRows && !gridOptionsMegered.noSelectRowCountInStatusBar && props.selectedRows.length > 0 && !props.disabled && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    style: {
      color: '#59ad0d',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      height: '100%'
    }
  }, /*#__PURE__*/React.createElement(_Divider, {
    type: "vertical",
    style: {
      borderColor: '#c8c7c7'
    }
  }), "\u5DF2\u9009", (_props$selectedRows = props.selectedRows) === null || _props$selectedRows === void 0 ? void 0 : _props$selectedRows.length, "\u6761", /*#__PURE__*/React.createElement("span", {
    title: "\u6E05\u7A7A\u6240\u9009",
    onClick: function onClick() {
      api === null || api === void 0 || api.deselectAll();
    },
    className: "clearBtn"
  }, /*#__PURE__*/React.createElement(ClearOutlined, null)), /*#__PURE__*/React.createElement(_Divider, {
    type: "vertical",
    style: {
      borderColor: '#c8c7c7'
    }
  }))))), /*#__PURE__*/React.createElement("div", {
    className: "stateBarExtra"
  }, gridOptionsMegered.StatusBarExtra), ((_gridRef$current22 = gridRef.current) === null || _gridRef$current22 === void 0 ? void 0 : _gridRef$current22.api) && ((_gridRef$current23 = gridRef.current) === null || _gridRef$current23 === void 0 || (_gridRef$current23 = _gridRef$current23.api) === null || _gridRef$current23 === void 0 ? void 0 : _gridRef$current23.getFilterModel()) && Object.keys((_gridRef$current24 = gridRef.current) === null || _gridRef$current24 === void 0 || (_gridRef$current24 = _gridRef$current24.api) === null || _gridRef$current24 === void 0 ? void 0 : _gridRef$current24.getFilterModel()).length > 0 && /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(_Button, {
    disabled: props.disabled,
    type: "link",
    onClick: function onClick() {
      var _gridRef$current25;
      (_gridRef$current25 = gridRef.current) === null || _gridRef$current25 === void 0 || (_gridRef$current25 = _gridRef$current25.api) === null || _gridRef$current25 === void 0 || _gridRef$current25.setFilterModel(null);
    },
    style: {
      color: '#ff4d4f',
      fontWeight: '550'
    },
    icon: /*#__PURE__*/React.createElement(ClearOutlined, null)
  }, "\u6E05\u9664\u6240\u6709\u7B5B\u9009\u6761\u4EF6(", Object.keys((_gridRef$current26 = gridRef.current) === null || _gridRef$current26 === void 0 || (_gridRef$current26 = _gridRef$current26.api) === null || _gridRef$current26 === void 0 ? void 0 : _gridRef$current26.getFilterModel()).length, "\u9879.)")), /*#__PURE__*/React.createElement("div", {
    style: {
      flex: '1 1'
    }
  }), ((_gridRef$current27 = gridRef.current) === null || _gridRef$current27 === void 0 ? void 0 : _gridRef$current27.api) && gridOptionsMegered.pagination && /*#__PURE__*/React.createElement(_ConfigProvider, {
    locale: zhCN,
    autoInsertSpaceInButton: false
  }, /*#__PURE__*/React.createElement(_Pagination, {
    disabled: props.disabled,
    hideOnSinglePage: true,
    responsive: true,
    showLessItems: true,
    pageSizeOptions: ['50', '100', '500', '1000'],
    current: currPageIndex,
    onChange: function onChange(page) {
      var _gridRef$current28;
      (_gridRef$current28 = gridRef.current) === null || _gridRef$current28 === void 0 || (_gridRef$current28 = _gridRef$current28.api) === null || _gridRef$current28 === void 0 || _gridRef$current28.paginationGoToPage(page - 1);
    },
    onShowSizeChange: function onShowSizeChange(current, size) {
      var _gridRef$current29;
      (_gridRef$current29 = gridRef.current) === null || _gridRef$current29 === void 0 || _gridRef$current29.api.paginationSetPageSize(size);
      setpageSize(size);
    },
    pageSize: pageSize || 50,
    total: rowcount,
    size: "small"
  })), !gridOptionsMegered.disableSideBarToggle && /*#__PURE__*/React.createElement(_Tooltip, {
    zIndex: 9999,
    placement: "topLeft",
    title: "\u663E\u793A/\u9690\u85CF \u8FB9\u680F",
    color: "#63aeff"
  }, /*#__PURE__*/React.createElement(_Button, {
    disabled: props.disabled,
    type: "link",
    className: "actionbtn",
    onClick: function onClick() {
      api === null || api === void 0 || api.setSideBar(!api.isSideBarVisible());
    },
    icon: /*#__PURE__*/React.createElement(ControlOutlined, null)
  })), !gridOptionsMegered.disableExportBtn && /*#__PURE__*/React.createElement(_Tooltip, {
    zIndex: 9999,
    placement: "topLeft",
    title: "\u5BFC\u51FA\u6570\u636E\u81F3Excel",
    color: "#63aeff"
  }, /*#__PURE__*/React.createElement(_Button, {
    disabled: props.disabled,
    type: "link",
    className: "actionbtn",
    onClick: function onClick() {
      //export
      if (props.inlineExportFunc) {
        props.inlineExportFunc(api);
      } else {
        //export
        var op = {
          fileName: "\u6570\u636E\u5BFC\u51FA.xlsx",
          sheetName: 'Sheet1',
          headerRowHeight: 30,
          processRowGroupCallback: function processRowGroupCallback(params) {
            return "\u6C47\u603B(".concat(params.node.key, ") ");
          }
        };
        api === null || api === void 0 || api.exportDataAsExcel(_objectSpread({}, op));
      }
    },
    icon: /*#__PURE__*/React.createElement(UploadOutlined, null)
  })), !gridOptionsMegered.disableFullScreen && /*#__PURE__*/React.createElement(_Tooltip, {
    zIndex: 9999,
    placement: "topLeft",
    title: "\u5168\u5C4F/\u53D6\u6D88\u5168\u5C4F",
    color: "#63aeff"
  }, /*#__PURE__*/React.createElement(_Button, {
    disabled: props.disabled,
    type: "link",
    className: "actionbtn",
    onClick: function onClick() {
      toggleFullscreen();
    },
    icon: isFullscreen ? /*#__PURE__*/React.createElement(FullscreenExitOutlined, null) : /*#__PURE__*/React.createElement(FullscreenOutlined, null),
    title: "\u5168\u5C4F/\u53D6\u6D88\u5168\u5C4F"
  }))), gridOptionsMegered.hideStatusBar && gridOptionsMegered.StatusBarExtra && /*#__PURE__*/React.createElement("div", {
    className: "".concat(gridOptionsMegered.theme === 'dark' ? 'pagination-bar-dark' : 'pagination-bar')
  }, /*#__PURE__*/React.createElement("div", {
    className: "stateBarExtra"
  }, gridOptionsMegered.StatusBarExtra)))));
}
export default /*#__PURE__*/React.forwardRef(XDataGrid);