function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/*
 * @Author: chenzenghua
 * @Date: 2021-06-30 10:17:28
 * @Last Modified by: yefei
 * @Last Modified time: 2023-02-22 12:10:56
 * @Des: 通用时间选择 格式化时间输入,丢弃难用的antd 时间选择器
 */

import { CalendarOutlined, CloseCircleOutlined, DoubleLeftOutlined, DoubleRightOutlined, LeftOutlined, RightOutlined } from '@ant-design/icons';
import cn from 'date-fns/locale/zh-CN';
import IMask from 'imask';
import moment from 'moment';
import React, { forwardRef, useEffect, useMemo, useRef, useState } from 'react';
import DatePicker, { registerLocale } from 'react-datepicker';
import { IMaskInput } from 'react-imask';
import "./datepicker.less";
import "./style.less";
registerLocale('zh-CN', cn);
function XDatePicker(props, ref) {
  var _props$value, _props$style, _props$minDate, _props$maxDate;
  var months = ['01月', '02月', '03月', '04月', '05月', '06月', '07月', '08月', '09月', '10月', '11月', '12月'];
  var _useState = useState(((_props$value = props.value) === null || _props$value === void 0 ? void 0 : _props$value.toDate()) || (props.defaultNull ? undefined : new Date())),
    _useState2 = _slicedToArray(_useState, 2),
    startDate = _useState2[0],
    setStartDate = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    focued = _useState4[0],
    setfocued = _useState4[1];
  var dateFormat = props.formatter || 'YYYY-MM-DD HH:mm';
  // 触发change
  var triggerChange = function triggerChange(date) {
    var _props$onChange;
    setStartDate(date === null || date === void 0 ? void 0 : date.toDate());
    (_props$onChange = props.onChange) === null || _props$onChange === void 0 || _props$onChange.call(props, date ? moment(date) : date);
  };
  useEffect(function () {
    if (props.value !== null) {
      var _props$value2;
      var s = ((_props$value2 = props.value) === null || _props$value2 === void 0 ? void 0 : _props$value2.toDate()) || (props.defaultNull ? undefined : new Date());
      if (startDate !== s) {
        setStartDate(s);
      }
    }
  }, [props.value]);
  var CustomInput = /*#__PURE__*/forwardRef(function (_ref, ref) {
    var value = _ref.value,
      onClick = _ref.onClick;
    var refmask = useRef(null);
    // useEffect(() => {
    //   if (refmask?.current) {
    //     refmask.current.element.focus()
    //   }
    // }, [refmask])
    // console.log(value)
    return /*#__PURE__*/React.createElement(IMaskInput, {
      disabled: props.disabled == true,
      readOnly: props.readOnly,
      onClick: onClick,
      mask: Date,
      overwrite: true,
      lazy: false,
      onChange: function onChange() {},
      value: value,
      ref: refmask
      // guide
      ,
      pattern: dateFormat,
      unmask: false,
      onAccept:
      // depending on prop above first argument is
      // `value` if `unmask=false`,
      // `unmaskedValue` if `unmask=true`,
      // `typedValue` if `unmask='typed'`

      function onAccept(v) {
        if (props.formatter === 'HH:mm' || props.showTimeSelectOnly === true) {
          var d = moment().format('YYYY-MM-DD ' + v + ':00');
          if (v && moment(d).isValid()) {
            if (moment(d).format(dateFormat) !== moment(startDate).format(dateFormat)) {
              triggerChange(moment(d));
            }
          }
        } else if (props.formatter === 'MM-DD') {
          var _d = startDate && "".concat(startDate.getFullYear(), "-").concat(v);
          if (v && moment(_d).isValid()) {
            if (moment(_d).format(dateFormat) !== moment(startDate).format(dateFormat)) {
              triggerChange(moment(_d));
            }
          }
        } else {
          if (v && moment(v).isValid()) {
            if (moment(v).format(dateFormat) !== moment(startDate).format(dateFormat)) {
              triggerChange(moment(v));
            }
          } else {
            if ((v === null || v === void 0 ? void 0 : v.toString().replaceAll(/[^0-9]/g, '')) === '') {
              triggerChange(null);
            }
          }
        }
      }
      // ...and more mask props in a guide
      ,
      format: function format(date) {
        return moment(date).format(dateFormat);
      },
      parse: function parse(str) {
        return moment(str, dateFormat);
      },
      blocks: {
        YYYY: {
          mask: IMask.MaskedRange,
          from: 1000,
          to: 2500
        },
        MM: {
          mask: IMask.MaskedRange,
          from: 1,
          to: 12
        },
        DD: {
          mask: IMask.MaskedRange,
          from: 1,
          to: 31
        },
        HH: {
          mask: IMask.MaskedRange,
          from: 0,
          to: 23
        },
        mm: {
          mask: IMask.MaskedRange,
          from: 0,
          to: 59
        },
        ss: {
          mask: IMask.MaskedRange,
          from: 0,
          to: 59
        }
      }
    });
  });
  var defaultWidth = function defaultWidth() {
    var width = 110;
    switch (dateFormat) {
      case 'YYYY-MM-DD':
        width = 110;
        break;
      case 'YYYY-MM-DD HH:mm':
        width = 145;
        break;
      case 'YYYY-MM-DD HH:mm:ss':
        width = 162;
        break;
      case 'HH:mm':
        width = 72;
        break;
      default:
        break;
    }
    return "".concat(width + (props.fastNav ? 30 : 0), "px");
  };
  var onPre = function onPre() {
    // eslint-disable-next-line no-nested-ternary
    var type = props.fastNav === '天' ? 'd' : props.fastNav === '小时' ? 'h' : 'M';
    var newDate = moment(startDate).add(-1, type);
    setStartDate(newDate.toDate());
    triggerChange(newDate);
  };
  var onNext = function onNext() {
    // eslint-disable-next-line no-nested-ternary
    var type = props.fastNav === '天' ? 'd' : props.fastNav === '小时' ? 'h' : 'M';
    var newDate = moment(startDate).add(1, type);
    setStartDate(newDate.toDate());
    triggerChange(newDate);
  };
  var years = useMemo(function () {
    var i = -(props.yearSelectorSubCount || 2);
    var arr = [];
    var thisYear = moment().year();
    while (i <= (props.yearSelectorPreCount || 10)) {
      arr.push(thisYear - i);
      i += 1;
    }
    return arr;
  }, [props.yearSelectorPreCount, props.yearSelectorSubCount]);
  return /*#__PURE__*/React.createElement("div", {
    className: "xinherc-dp ".concat(props.smallsizePop ? 'xinherc-dp-small' : '', " ").concat(props.smallsize ? 'size-small' : '', " ").concat(props.disabled ? 'xinherc-dp-disabled' : ''),
    style: _objectSpread(_objectSpread({}, props.style), {}, {
      width: ((_props$style = props.style) === null || _props$style === void 0 ? void 0 : _props$style.width) || defaultWidth(),
      flexShrink: 0
    }),
    onMouseEnter: props.allowClear ? function () {
      setfocued(true);
    } : undefined,
    onMouseLeave: props.allowClear ? function () {
      setfocued(false);
    } : undefined
  }, focued && /*#__PURE__*/React.createElement(CloseCircleOutlined, {
    className: "dp-icon-close",
    style: {
      right: props.fastNav ? '20px' : '8px',
      cursor: 'pointer'
    },
    onClick: function onClick() {
      var _props$onChange2;
      setStartDate(undefined);
      (_props$onChange2 = props.onChange) === null || _props$onChange2 === void 0 || _props$onChange2.call(props, null);
    }
  }) || /*#__PURE__*/React.createElement(CalendarOutlined, {
    className: "dp-icon",
    style: {
      right: props.fastNav ? '20px' : '8px'
    }
  }), props.fastNav && /*#__PURE__*/React.createElement("div", {
    className: "shortcut",
    title: "\u4E0A\u4E00".concat(props.fastNav),
    onClick: onPre
  }, /*#__PURE__*/React.createElement(LeftOutlined, null)), /*#__PURE__*/React.createElement(DatePicker, {
    ref: ref,
    renderCustomHeader: function renderCustomHeader(_ref2) {
      var date = _ref2.date,
        changeYear = _ref2.changeYear,
        changeMonth = _ref2.changeMonth,
        decreaseMonth = _ref2.decreaseMonth,
        decreaseYear = _ref2.decreaseYear,
        increaseYear = _ref2.increaseYear,
        increaseMonth = _ref2.increaseMonth,
        prevMonthButtonDisabled = _ref2.prevMonthButtonDisabled,
        prevYearButtonDisabled = _ref2.prevYearButtonDisabled,
        nextYearButtonDisabled = _ref2.nextYearButtonDisabled,
        nextMonthButtonDisabled = _ref2.nextMonthButtonDisabled;
      return /*#__PURE__*/React.createElement("div", {
        className: "dp-head"
      }, /*#__PURE__*/React.createElement("button", {
        onClick: decreaseYear,
        disabled: prevYearButtonDisabled,
        title: "\u4E0A\u4E00\u5E74"
      }, /*#__PURE__*/React.createElement(DoubleLeftOutlined, null)), /*#__PURE__*/React.createElement("button", {
        onClick: decreaseMonth,
        disabled: prevMonthButtonDisabled,
        title: "\u4E0A\u4E00\u6708"
      }, /*#__PURE__*/React.createElement(LeftOutlined, null)), /*#__PURE__*/React.createElement("select", {
        value: moment(date).year(),
        onChange: function onChange(_ref3) {
          var value = _ref3.target.value;
          return changeYear(value);
        }
      }, years.map(function (option) {
        return /*#__PURE__*/React.createElement("option", {
          key: option,
          value: option
        }, option);
      })), /*#__PURE__*/React.createElement("select", {
        value: months[moment(date).month()],
        onChange: function onChange(_ref4) {
          var value = _ref4.target.value;
          return changeMonth(months.indexOf(value));
        }
      }, months.map(function (option) {
        return /*#__PURE__*/React.createElement("option", {
          key: option,
          value: option
        }, option);
      })), /*#__PURE__*/React.createElement("button", {
        onClick: increaseMonth,
        disabled: nextMonthButtonDisabled,
        title: "\u4E0B\u4E00\u6708"
      }, /*#__PURE__*/React.createElement(RightOutlined, null)), /*#__PURE__*/React.createElement("button", {
        onClick: increaseYear,
        disabled: nextYearButtonDisabled,
        title: "\u4E0B\u4E00\u5E74"
      }, /*#__PURE__*/React.createElement(DoubleRightOutlined, null)));
    },
    onYearChange: function onYearChange(e) {
      //setcurrYear(e.getFullYear())
    },
    disabled: props.disabled == true,
    todayButton: "\u4ECA\u5929",
    timeFormat: "HH:mm",
    closeOnScroll: true,
    autoFocus: false,
    disabledKeyboardNavigation: true,
    showTimeSelect: props.formatter === 'YYYY-MM-DD' ? false : props.showTimeSelect !== false,
    selected: startDate,
    showTimeSelectOnly: props.formatter === 'HH:mm' || props.showTimeSelectOnly === true,
    onChange: function onChange(e) {
      triggerChange(moment(e));
    }
    // date-fns 跟moment 定义的格式不一致
    ,
    dateFormat: dateFormat.replace('YYYY', 'yyyy').replace('DD', 'dd'),
    customInput: /*#__PURE__*/React.createElement(CustomInput, {
      ref: ref
    }),
    locale: "zh-CN",
    timeCaption: "\u65F6\u95F4\u70B9",
    timeIntervals: props.timeIntervals || 30,
    fixedHeight: true,
    showPopperArrow: false,
    showWeekNumbers: props.showWeekNumbers,
    weekLabel: "\u5468\u6B21"
    // @ts-ignore
    ,
    popperModifiers: [{
      name: 'offset',
      options: {
        offset: props.popOffset || [0, -8]
      }
    }],
    minDate: (_props$minDate = props.minDate) === null || _props$minDate === void 0 ? void 0 : _props$minDate.toDate(),
    maxDate: (_props$maxDate = props.maxDate) === null || _props$maxDate === void 0 ? void 0 : _props$maxDate.toDate()
  }), props.fastNav && /*#__PURE__*/React.createElement("div", {
    className: "shortcut righticon",
    title: "\u4E0B\u4E00".concat(props.fastNav),
    onClick: onNext
  }, /*#__PURE__*/React.createElement(RightOutlined, null)));
}
export default /*#__PURE__*/forwardRef(XDatePicker);