function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
import "antd/es/modal/style";
import _Modal from "antd/es/modal";
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/*
 * @Des:可拖动弹层
 * @Author: chenzenghua
 * @Date: 2021-07-26 11:39:20
 * @Last Modified by:   chenzenghua
 * @Last Modified time: 2021-07-26 11:39:20
 */
import { BorderOutlined, MinusOutlined } from '@ant-design/icons';
import { omit } from 'lodash';
import React, { useEffect, useMemo, useRef, useState } from 'react';
import Draggable from 'react-draggable';
import "./styles.less";
var DraggableModal = function DraggableModal(props) {
  var _useState = useState({
      left: 0,
      top: 0,
      bottom: 0,
      right: 0
    }),
    _useState2 = _slicedToArray(_useState, 2),
    bounds = _useState2[0],
    setbounds = _useState2[1];
  var ref = useRef();
  var _useState3 = useState(true),
    _useState4 = _slicedToArray(_useState3, 2),
    disabled = _useState4[0],
    setdisabled = _useState4[1];
  var _useState5 = useState(false),
    _useState6 = _slicedToArray(_useState5, 2),
    bigSize = _useState6[0],
    setBigSize = _useState6[1];
  var _useState7 = useState(props.width || 416),
    _useState8 = _slicedToArray(_useState7, 2),
    width = _useState8[0],
    setWidth = _useState8[1];
  var _useState9 = useState(props.height || 0),
    _useState10 = _slicedToArray(_useState9, 2),
    height = _useState10[0],
    setHeight = _useState10[1];
  var _onStart = function onStart(event, uiData) {
    var _window, _ref$current;
    var _window$document$docu = (_window = window) === null || _window === void 0 || (_window = _window.document) === null || _window === void 0 ? void 0 : _window.documentElement,
      clientWidth = _window$document$docu.clientWidth,
      clientHeight = _window$document$docu.clientHeight;
    var targetRect = ref === null || ref === void 0 || (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.getBoundingClientRect();
    setbounds({
      left: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.left) + (uiData === null || uiData === void 0 ? void 0 : uiData.x),
      right: clientWidth - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.right) - (uiData === null || uiData === void 0 ? void 0 : uiData.x)),
      top: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.top) + (uiData === null || uiData === void 0 ? void 0 : uiData.y),
      bottom: clientHeight - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.bottom) - (uiData === null || uiData === void 0 ? void 0 : uiData.y))
    });
  };
  useEffect(function () {
    setWidth(props.width || 416);
  }, [props.width]);
  useEffect(function () {
    setHeight(props.height || 0);
  }, [props.height]);
  useEffect(function () {
    if (bigSize) {
      setWidth('95vw');
      setHeight('90vh');
    } else {
      setWidth(props.width || 416);
      setHeight(props.height || 0);
    }
  }, [bigSize]);
  var normalCss = useMemo(function () {
    return {
      height: height ? height : '100%'
    };
  }, [height]);
  var modalProperties = useMemo(function () {
    return bigSize ? omit(props.modalProperties, ['height', 'style']) : omit(props.modalProperties, ['height']);
  }, [props.modalProperties, bigSize]);
  return /*#__PURE__*/React.createElement(_Modal, _extends({
    open: props.visible,
    className: "xinherc-xdraggablemodal ".concat(props.className),
    title: props.hiddenTitle ? undefined : /*#__PURE__*/React.createElement("div", {
      style: {
        width: '100%',
        cursor: 'move',
        fontSize: '13px'
      },
      onMouseOver: function onMouseOver() {
        if (disabled) {
          setdisabled(false);
        }
      },
      onMouseOut: function onMouseOut() {
        setdisabled(true);
      }
    }, props.title || '标题', props.sizeControl && /*#__PURE__*/React.createElement("button", {
      type: "button",
      onClick: function onClick() {
        setBigSize(!bigSize);
      },
      className: "ant-modal-close",
      style: {
        right: 42
      }
    }, bigSize ? /*#__PURE__*/React.createElement(MinusOutlined, null) : /*#__PURE__*/React.createElement(BorderOutlined, null))),
    bodyStyle: props.bodyStyle,
    closable: props.closable,
    width: width || undefined,
    maskClosable: props.maskClosable || false,
    mask: props.mask,
    destroyOnClose: props.destroyOnClose || true,
    onCancel: props.onCancel,
    footer: props.footer || false,
    modalRender: function modalRender(modal) {
      return /*#__PURE__*/React.createElement(Draggable, _defineProperty({
        defaultPosition: props.defaultPosition || undefined,
        onStart: function onStart(e) {
          var _props$onStart;
          return (_props$onStart = props.onStart) === null || _props$onStart === void 0 ? void 0 : _props$onStart.call(props, e);
        },
        onStop: function onStop(e) {
          var _props$onStop;
          return (_props$onStop = props.onStop) === null || _props$onStop === void 0 ? void 0 : _props$onStop.call(props, e);
        },
        disabled: disabled,
        bounds: bounds
        //@ts-ignore
      }, "onStart", function onStart(event, uiData) {
        return _onStart(event, uiData);
      }), /*#__PURE__*/React.createElement("div", {
        style: {
          height: '100%',
          width: '100%'
        },
        ref: ref
      }, modal));
    }
  }, modalProperties), /*#__PURE__*/React.createElement("div", {
    style: normalCss
  }, " ", props.children));
};
export default DraggableModal;