/*
 * @Author: chenzenghua
 * @Date: 2021-07-26 11:40:56
 * @Last Modified by:   chenzenghua
 * @Last Modified time: 2021-07-26 11:40:56
 * @Des:悬浮层
 */

import React from 'react';
import Draggable from 'react-draggable';
var XFloatPanel = function XFloatPanel(props) {
  return /*#__PURE__*/React.createElement(Draggable, {
    onStart: function onStart(e) {
      var _props$onStart;
      return (_props$onStart = props.onStart) === null || _props$onStart === void 0 ? void 0 : _props$onStart.call(props, e);
    },
    onStop: function onStop(e) {
      var _props$onStop;
      return (_props$onStop = props.onStop) === null || _props$onStop === void 0 ? void 0 : _props$onStop.call(props, e);
    },
    bounds: props.bounds || 'body',
    defaultPosition: props.defaultPosition || undefined
  }, props.children);
};
export default XFloatPanel;