import "antd/es/menu/style";
import _Menu from "antd/es/menu";
import "antd/es/layout/style";
import _Layout from "antd/es/layout";
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import extralogo from "../assets/extralogo.png";
import AutoScrollWrapper from "../components/AutoScrollWrapper";
import { RightOutlined } from '@ant-design/icons';
import { useUpdateEffect } from 'ahooks';
import React, { useCallback, useState } from 'react';
import "./styles.less";
var Sider = _Layout.Sider;
var XNavMenuProps = function XNavMenuProps(props) {
  var _useState = useState(props.collapased),
    _useState2 = _slicedToArray(_useState, 2),
    collapased = _useState2[0],
    setcollapased = _useState2[1];
  var _useState3 = useState(1000),
    _useState4 = _slicedToArray(_useState3, 2),
    refreshFlag = _useState4[0],
    setrefreshFlag = _useState4[1];
  var popLevel3 = function popLevel3(e) {
    e.domEvent.currentTarget.onclick = function (e) {
      //阻止原本的菜单展开行为
      e.stopPropagation();
      e.preventDefault();
    };

    //var offsetX = event.clientX - elementRect.left
    var controlId = e.domEvent.currentTarget.getAttribute('aria-controls');
    var element = document.querySelector("#".concat(controlId));
    if (!element) {
      console.log('未找到子菜单元素');
      return;
    }

    //清空已有
    var refreshEle = document.querySelectorAll('.level3popup');
    refreshEle === null || refreshEle === void 0 || refreshEle.forEach(function (item) {
      item.classList.remove('level3popup');
    });

    //hack样式
    element.parentNode.classList.add('ant-menu-submenu-open');
    element.classList.add('level3popup');
    element.parentNode.classList.remove('ant-menu-hidden');
    element.style.left = "".concat(e.domEvent.currentTarget.getBoundingClientRect().right, "px");
    element.style.top = "".concat(e.domEvent.currentTarget.getBoundingClientRect().top, "px");
  };
  var createMenu = useCallback(function () {
    if (props.level3MenuMode === 'popup') {
      if (props.menus) {
        props.menus.forEach(function (l1) {
          if (l1 !== null && l1 !== void 0 && l1.children) {
            l1.children.forEach(function (l2) {
              if (l2.children) {
                //有三级菜单
                l2.onTitleMouseEnter = function (e) {
                  popLevel3(e);
                };
                l2.expandIcon = /*#__PURE__*/React.createElement(RightOutlined, {
                  className: "l3popicon"
                });
              }
            });
          }
        });
      }
    }
    return props.menus;
  }, [props.menus, collapased, props.selectedKeys]);
  useUpdateEffect(function () {
    setcollapased(props.collapased);
  }, [props.collapased]);
  useUpdateEffect(function () {
    //重新渲染
    setrefreshFlag(refreshFlag + 1);
  }, [props.level3MenuMode]);
  var handleMenuClick = function handleMenuClick(_ref) {
    var _props$onMenuClick;
    var key = _ref.key,
      keyPath = _ref.keyPath;
    var menu;
    if (keyPath.length === 1) {
      menu = props.menus.find(function (p) {
        return (p === null || p === void 0 ? void 0 : p.key) === key;
      });
    } else {
      var paths = keyPath.reverse();
      // 第一层
      var m = props.menus.find(function (p1) {
        return (p1 === null || p1 === void 0 ? void 0 : p1.key) === paths[0];
      });
      paths.forEach(function (k1, index) {
        if (index > 0) {
          var _m;
          //@ts-ignore
          m = (_m = m) === null || _m === void 0 || (_m = _m.children) === null || _m === void 0 ? void 0 : _m.find(function (sub) {
            return sub.key === k1;
          });
        }
      });
      menu = m;
    }
    (_props$onMenuClick = props.onMenuClick) === null || _props$onMenuClick === void 0 || _props$onMenuClick.call(props, menu, key, keyPath);
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "xinhe-xnavmenu",
    onMouseLeave: function onMouseLeave() {
      if (props.level3MenuMode === 'popup') {
        var refreshEle = document.querySelectorAll('.level3popup');
        refreshEle === null || refreshEle === void 0 || refreshEle.forEach(function (item) {
          item.classList.remove('level3popup');
        });
      }
    },
    key: "x-menu-".concat(refreshFlag)
  }, /*#__PURE__*/React.createElement(_Layout, null, /*#__PURE__*/React.createElement(Sider, {
    className: "nav nav".concat(props.theme || 'dark'),
    collapsible: true,
    collapsedWidth: "50px",
    collapsed: collapased,
    onCollapse: function onCollapse(c) {
      setcollapased(c);
    },
    trigger: props.hideTrigger ? null : undefined
  }, props.collapsedLogo && collapased && /*#__PURE__*/React.createElement("div", {
    className: "logoWrapper"
  }, props.collapsedLogo), (props.expandedLogo || props.collapsedLogo) && !collapased && /*#__PURE__*/React.createElement("div", {
    className: "logoWrapper ".concat(props.hideTopLogo ? 'hide-logo' : '')
  }, props.expandedLogo || props.collapsedLogo), /*#__PURE__*/React.createElement("div", {
    className: "menuWrapper",
    style: {
      flex: '1 1'
    }
  }, /*#__PURE__*/React.createElement(AutoScrollWrapper, null, /*#__PURE__*/React.createElement(_Menu, _extends({
    inlineIndent: 16,
    forceSubMenuRender: props.level3MenuMode === 'popup',
    onClick: handleMenuClick,
    defaultSelectedKeys: props.defaultSelectedKeys,
    selectedKeys: props.selectedKeys,
    subMenuCloseDelay: 0.3,
    mode: "inline",
    theme: props.theme || 'dark',
    items: createMenu()
  }, props.menuProps)))), props.bottomMenus && /*#__PURE__*/React.createElement("div", {
    className: "menuWrapper",
    style: {
      flex: '0 0',
      height: "".concat(props.bottomMenuHeight || '100px')
    }
  }, /*#__PURE__*/React.createElement(AutoScrollWrapper, null, /*#__PURE__*/React.createElement(_Menu, {
    inlineIndent: 16,
    forceSubMenuRender: props.level3MenuMode === 'popup',
    onClick: handleMenuClick,
    defaultSelectedKeys: props.defaultSelectedKeys,
    selectedKeys: props.selectedKeys,
    subMenuCloseDelay: 0.3,
    mode: "inline",
    theme: props.theme || 'dark',
    items: props.bottomMenus
  }))), /*#__PURE__*/React.createElement("div", {
    className: "extra-info",
    style: {
      display: collapased || props.hideBottomLog ? 'none' : 'flex'
    }
  }, /*#__PURE__*/React.createElement("img", {
    src: extralogo
  })))));
};
export default XNavMenuProps;