/*
 * @Author: chenzenghua
 * @Date: 2023-12-15 13:39:21
 * @LastEditTime: 2023-12-15 14:33:22
 * @LastEditors: chenzenghua
 * @Description: 
 */
/** converting camel-cased strings to be lowercase and link it with Separato */
export function toLowercaseSeparator(key) {
  return key.replace(/([A-Z])/g, '-$1').toLowerCase();
}
export function getStyleStr(style) {
  return Object.keys(style)
  //@ts-ignore
  .map(function (key) {
    return "".concat(toLowercaseSeparator(key), ": ").concat(style[key], ";");
  }).join(' ');
}

/** Returns the ratio of the device's physical pixel resolution to the css pixel resolution */
export function getPixelRatio() {
  return window.devicePixelRatio || 1;
}

/** Whether to re-render the watermark */
export var reRendering = function reRendering(mutation, isWatermarkEle) {
  var flag = false;
  // Whether to delete the watermark node
  if (mutation.removedNodes.length) {
    flag = Array.from(mutation.removedNodes).some(function (node) {
      return isWatermarkEle(node);
    });
  }
  // Whether the watermark dom property value has been modified
  if (mutation.type === 'attributes' && isWatermarkEle(mutation.target)) {
    flag = true;
  }
  return flag;
};