function desensiteFunc(str, beginLen, endLen) {
  var len = str.length;
  var firstStr = str.substr(0, beginLen);
  var lastStr = str.substr(len - endLen, len);
  var middleStr = "".padStart(str.length - beginLen - endLen, "*");
  return firstStr + middleStr + lastStr;
}
var desensitive = function desensitive(type, value) {
  if (!value) {
    return value;
  }
  switch (type) {
    case "身份证":
      if (value.length >= 9) {
        return desensiteFunc(value, 3, 4);
      } else return value;
    case "手机号":
      if (value.length >= 8) {
        return desensiteFunc(value, 3, 4);
      } else return value;
    case "地址":
      if (value.length >= 8) {
        return desensiteFunc(value, 3, 4);
      } else return value;
    default:
      return value;
  }
};
export default desensitive;