export declare const XRegExps: {
    _reg_Mobile: string;
    _reg_Password: string;
    _reg_Email: string;
    _reg_Number: string;
    _reg_Chinese: string;
    /**
     * 身份证
     */
    _reg_IDCard: string;
    /**
     * 正整数
     */
    _reg_PosPattern: string;
    /**
     * 负整数
     */
    _reg_negPattern: string;
    /**
     * 整数
     */
    _reg_IntPattern: string;
};
export declare const getDaddy: () => string;
/**
 * 验证输入值是否符合给定正则表达式
 * @param pattern
 * @param value
 * @returns
 */
export declare const ExpCheck: (pattern: string, value: string) => boolean;
export declare const desensitive: (type: '身份证' | '手机号' | '地址', value: string) => string;
export * as XFunc from '../utils/XFunc';
