import type { ToastContainerProps } from 'react-toastify';
import type { ReactNode } from 'react';
import React from 'react';
import './style.less';
declare const msg: {
    error: (content: React.ReactNode, options?: ToastContainerProps) => void;
    info: (content: React.ReactNode, options?: ToastContainerProps) => void;
    success: (content: React.ReactNode, options?: ToastContainerProps) => void;
    warn: (content: React.ReactNode, options?: ToastContainerProps) => void;
    loading: (content?: string, key?: string) => import("antd/lib/message").MessageType;
    loadingComplete: (content?: string, key?: string) => import("antd/lib/message").MessageType;
    confirm: (content: ReactNode, title?: ReactNode, width?: string | number) => Promise<unknown>;
};
export default msg;
