import React from 'react';
import './styles.less';
interface IProps {
    /**
     * 颜色值Hex
     */
    value?: string;
    onChange?: (value: string) => void;
    style?: React.CSSProperties;
    /**
     * 允许选择透明度
     * @default false
     */
    allowAlpha?: boolean;
    top?: number;
    left?: number;
}
declare function ColorPicker(props: IProps): React.JSX.Element;
export default ColorPicker;
