function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/*
 * @Author: chenzenghua
 * @Date: 2022-11-25 14:39:04
 * @LastEditTime: 2023-08-11 09:45:54
 * @LastEditors: chenzenghua
 * @Description:
 */

/**
 * 跳转到指定行索引
 * @param gridApi
 * @param index
 */
var turnToIndex = function turnToIndex(gridApi, index) {
  gridApi.ensureIndexVisible(index, 'middle');
  // 闪烁一下
  var rowNode = gridApi.getDisplayedRowAtIndex(index);
  if (rowNode) {
    gridApi === null || gridApi === void 0 || gridApi.flashCells({
      rowNodes: [rowNode],
      flashDelay: 2000,
      fadeDelay: 1000
    });
  }
};

/**
 * 跳转到指定ID行
 * @param gridApi
 * @param IDValue ID值
 *  @deprecated 弃用,请使用 TurnToRowByRowID
 */

var turnToRowOfValue = function turnToRowOfValue(gridApi, IDValue) {
  // const rowNode = gridApi.getRowNode(IDValue)
  // const rowNode = gridApi.getDisplayedRowAtIndex(55)
  var rowNode = gridApi.getRowNode(IDValue);
  gridApi.ensureNodeVisible(rowNode, 'middle');
  // 闪烁一下
  if (rowNode) {
    gridApi === null || gridApi === void 0 || gridApi.flashCells({
      rowNodes: [rowNode],
      flashDelay: 2000,
      fadeDelay: 1000
    });
  }
};
var TurnToRowByRowID = function TurnToRowByRowID(gridApi, IDValue) {
  // const rowNode = gridApi.getRowNode(IDValue)
  // const rowNode = gridApi.getDisplayedRowAtIndex(55)
  var rowNode = gridApi.getRowNode(IDValue);
  gridApi.ensureNodeVisible(rowNode, 'middle');
  // 闪烁一下
  if (rowNode) {
    gridApi === null || gridApi === void 0 || gridApi.flashCells({
      rowNodes: [rowNode],
      flashDelay: 2000,
      fadeDelay: 1000
    });
  }
};
/**
 * 导出Excel
 * @param gridApi
 * @param options 导出参数 详:https://www.ag-grid.com/react-data-grid/excel-export-api/
 */
var exportToExcel = function exportToExcel(gridApi, options) {
  var op = _objectSpread({
    fileName: '导出.xlsx',
    sheetName: 'Sheet1',
    headerRowHeight: 30
  }, options);
  gridApi === null || gridApi === void 0 || gridApi.exportDataAsExcel(_objectSpread({}, op));
};
var gridTools = {
  turnToIndex: turnToIndex,
  turnToRowOfValue: turnToRowOfValue,
  exportToExcel: exportToExcel
};
export default gridTools;