import React from 'react';
import { FieldSelectorProps } from 'react-querybuilder';
import { IFieldType, IPredicateItemDef, IResutType, IValueItemDef } from '../../typing';
type FieldSelectorPropsExt = FieldSelectorProps & {
    getPredicateTypeDef: (fieldType?: string) => IPredicateItemDef;
    onChangeData?: (data: IFieldType[]) => void;
    getResultTypeList?: (CLASS_ID?: string) => IResutType[];
    onChangeResultType?: (data: any) => void;
    getValueList?: (classID?: string, resultTypeID?: string, operatorName?: string) => IValueItemDef;
    onChangeJudgeResult?: (data: any) => void;
};
export default function Index(props: FieldSelectorPropsExt): React.JSX.Element;
export {};
