import "antd/es/tooltip/style";
import _Tooltip from "antd/es/tooltip";
import "antd/es/input-number/style";
import _InputNumber from "antd/es/input-number";
import "antd/es/select/style";
import _Select from "antd/es/select";
import "antd/es/tag/style";
import _Tag from "antd/es/tag";
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/*
 * @Author: chenzenghua
 * @Date: 2023-01-15 15:56:00
 * @LastEditTime: 2023-12-15 14:42:23
 * @LastEditors: chenzenghua
 * @Description:
 */
import { useDebounceFn } from 'ahooks';
import { cloneDeep, eq, isEmpty } from 'lodash';
import React, { useEffect, useState } from 'react';
import XSelector from "../../../XSelector";
export default function Index(props) {
  var _props$value3, _props$value4, _props$value5, _props$value6, _props$value7, _props$value8, _props$value9, _props$value10, _props$value11, _props$value12, _props$value13, _props$value14;
  var _ref = props.value,
    CLASS_NAME = _ref.CLASS_NAME,
    CLASS_TYPE_TAG = _ref.CLASS_TYPE_TAG,
    CLASS_TYPE_ID = _ref.CLASS_TYPE_ID,
    CLASS_ID = _ref.CLASS_ID,
    resultType_type = _ref.resultType_type;
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    resultTypeList = _useState2[0],
    setresultTypeList = _useState2[1];
  var _useState3 = useState(),
    _useState4 = _slicedToArray(_useState3, 2),
    childValueListdef = _useState4[0],
    setchildValueListdef = _useState4[1];
  useEffect(function () {
    var _props$getResultTypeL, _props$value;
    var list = (_props$getResultTypeL = props.getResultTypeList) === null || _props$getResultTypeL === void 0 ? void 0 : _props$getResultTypeL.call(props, CLASS_ID);
    setresultTypeList(list);
    //根据结果类型获取关联选择数据
    //@ts-ignore
    if ((_props$value = props.value) !== null && _props$value !== void 0 && _props$value.resultType) {
      //@ts-ignore
      var x = list === null || list === void 0 ? void 0 : list.find(function (p) {
        var _props$value2;
        return p.key === ((_props$value2 = props.value) === null || _props$value2 === void 0 ? void 0 : _props$value2.resultType);
      });
      if (x) {
        if (x !== null && x !== void 0 && x.resultType && (x === null || x === void 0 ? void 0 : x.resultType) === 'both') {
          var _props$getValueList;
          var df = (_props$getValueList = props.getValueList) === null || _props$getValueList === void 0 ? void 0 : _props$getValueList.call(props, CLASS_ID, x.key);
          setchildValueListdef(df);
        } else {
          setchildValueListdef(undefined);
        }
      }
    }
  }, [CLASS_TYPE_ID]);
  var onChangeResultType = function onChangeResultType(e) {
    var _df$data, _props$getValueList2, _props$onChangeResult;
    var df = props.getPredicateTypeDef(CLASS_TYPE_ID);
    var typeDef = (_df$data = df.data) === null || _df$data === void 0 ? void 0 : _df$data.find(function (p) {
      return p.CLASS_ID === CLASS_ID;
    });
    var x = resultTypeList === null || resultTypeList === void 0 ? void 0 : resultTypeList.find(function (p) {
      return p.key === e;
    });
    var valuedef = (_props$getValueList2 = props.getValueList) === null || _props$getValueList2 === void 0 ? void 0 : _props$getValueList2.call(props, CLASS_ID, x === null || x === void 0 ? void 0 : x.key);
    //@ts-ignore
    x['INPUT_TYPE'] = valuedef !== null && valuedef !== void 0 && valuedef.INPUT_TYPE ? valuedef.INPUT_TYPE : typeDef.INPUT_TYPE;
    (_props$onChangeResult = props.onChangeResultType) === null || _props$onChangeResult === void 0 || _props$onChangeResult.call(props, x);
  };

  //时间间隔，回溯天数修改
  var onChangeData = useDebounceFn(function (e, type) {
    var _props$onChangeData;
    var list = cloneDeep(props.value);
    list[type] = e;
    props === null || props === void 0 || (_props$onChangeData = props.onChangeData) === null || _props$onChangeData === void 0 || _props$onChangeData.call(props, list);
  }, {
    wait: 500
  }).run;
  return /*#__PURE__*/React.createElement(React.Fragment, null, CLASS_TYPE_TAG && (typeof CLASS_TYPE_TAG === 'string' ? /*#__PURE__*/React.createElement(_Tag, {
    style: {
      borderRadius: '50%'
    },
    color: "magenta"
  }, CLASS_TYPE_TAG) : CLASS_TYPE_TAG === null || CLASS_TYPE_TAG === void 0 ? void 0 : CLASS_TYPE_TAG.map(function (tag) {
    if (!isEmpty(tag)) {
      return /*#__PURE__*/React.createElement(_Tag, {
        style: tag.style ? tag.style : {},
        color: tag.color || 'magenta'
      }, (tag === null || tag === void 0 ? void 0 : tag.name) || tag);
    } else {
      return /*#__PURE__*/React.createElement(React.Fragment, null);
    }
  })), /*#__PURE__*/React.createElement(_Tag, {
    color: "#2db7f5"
  }, CLASS_NAME),
  //@ts-ignore
  ((_props$value3 = props.value) === null || _props$value3 === void 0 ? void 0 : _props$value3.resultType) && /*#__PURE__*/React.createElement(React.Fragment, null, isEmpty(resultTypeList) ? /*#__PURE__*/React.createElement(_Select, {
    style: {
      width: '150px'
    },
    options: []
    //@ts-ignore
    ,
    defaultValue: (_props$value4 = props.value) === null || _props$value4 === void 0 ? void 0 : _props$value4.resultTypeLabel
  }) : /*#__PURE__*/React.createElement(_Select, {
    style: {
      width: '150px'
    },
    options: resultTypeList
    //@ts-ignore
    ,
    value: (_props$value5 = props.value) === null || _props$value5 === void 0 ? void 0 : _props$value5.resultType,
    fieldNames: {
      value: 'key',
      label: 'name'
    },
    onChange: onChangeResultType
  })),
  //@ts-ignore
  (!!((_props$value6 = props.value) !== null && _props$value6 !== void 0 && _props$value6.reviewDay) || ((_props$value7 = props.value) === null || _props$value7 === void 0 ? void 0 : _props$value7.reviewDay) === '0') && /*#__PURE__*/React.createElement(_Tooltip, {
    title: "\u56DE\u6EAF\u5929\u6570"
  }, /*#__PURE__*/React.createElement(_InputNumber, {
    style: {
      width: '130px'
    }
    //@ts-ignore
    ,
    defaultValue: (_props$value8 = props.value) === null || _props$value8 === void 0 ? void 0 : _props$value8.reviewDay,
    onBlur: function onBlur(e) {
      var _props$onChangeData2;
      // onChangeData(e.target.value || '0', 'reviewDay')
      var list = cloneDeep(props.value);
      list['reviewDay'] = e.target.value || '0';
      props === null || props === void 0 || (_props$onChangeData2 = props.onChangeData) === null || _props$onChangeData2 === void 0 || _props$onChangeData2.call(props, list);
    },
    addonAfter: "\u5929\u5185"
  })),
  //@ts-ignore
  (!!((_props$value9 = props.value) !== null && _props$value9 !== void 0 && _props$value9.dateRange) || ((_props$value10 = props.value) === null || _props$value10 === void 0 ? void 0 : _props$value10.dateRange) === '0') && /*#__PURE__*/React.createElement(_Tooltip, {
    title: "\u65F6\u95F4\u95F4\u9694"
  }, /*#__PURE__*/React.createElement(_InputNumber, {
    style: {
      minWidth: '50px'
    }
    //@ts-ignore
    ,
    defaultValue: (_props$value11 = props.value) === null || _props$value11 === void 0 ? void 0 : _props$value11.dateRange,
    onBlur: function onBlur(e) {
      var _props$onChangeData3;
      // onChangeData(e.target.value || '0', 'dateRange')
      var list = cloneDeep(props.value);
      list['dateRange'] = e.target.value || '0';
      props === null || props === void 0 || (_props$onChangeData3 = props.onChangeData) === null || _props$onChangeData3 === void 0 || _props$onChangeData3.call(props, list);
    }
  })),
  //@ts-ignore
  ((_props$value12 = props.value) === null || _props$value12 === void 0 ? void 0 : _props$value12.judgeResult) && (resultType_type === 'both' || childValueListdef) && /*#__PURE__*/React.createElement(XSelector, {
    style: {
      minWidth: '140px'
    }
    //@ts-ignore
    ,
    defaultValue: _typeof((_props$value13 = props.value) === null || _props$value13 === void 0 ? void 0 : _props$value13.judgeResult) === 'object' ? (_props$value14 = props.value) === null || _props$value14 === void 0 ? void 0 : _props$value14.judgeResult : [],
    onSelectChange: function onSelectChange(e) {
      var _props$value15;
      //@ts-ignore
      var isEqual = eq(e, (_props$value15 = props.value) === null || _props$value15 === void 0 ? void 0 : _props$value15.judgeResult);
      if (!isEqual) {
        var _props$onChangeJudgeR;
        (_props$onChangeJudgeR = props.onChangeJudgeResult) === null || _props$onChangeJudgeR === void 0 || _props$onChangeJudgeR.call(props, e);
      }
    },
    maxTagCount: 10,
    mode: 'multiple',
    valueRow: "VALUE_ID",
    nameRow: "VALUE_NAME",
    colDef: (childValueListdef === null || childValueListdef === void 0 ? void 0 : childValueListdef.colDef) || [],
    data: childValueListdef === null || childValueListdef === void 0 ? void 0 : childValueListdef.data,
    showSearch: true
  }));
}