import "antd/es/input/style";
import _Input from "antd/es/input";
import "antd/es/input-number/style";
import _InputNumber from "antd/es/input-number";
import "antd/es/auto-complete/style";
import _AutoComplete from "antd/es/auto-complete";
import "antd/es/select/style";
import _Select from "antd/es/select";
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
/*
 * @Author: chenzenghua
 * @Date: 2023-01-15 15:56:00
 * @LastEditTime: 2023-06-21 11:16:00
 * @LastEditors: chenzenghua
 * @Description:
 */
import { useDebounceFn, useUpdateEffect } from 'ahooks';
import { cloneDeep, eq } from 'lodash';
import moment from 'moment';
import React, { Fragment, useEffect, useState } from 'react';
import XDatePicker from "../../../XDatePicker";
import XSelector from "../../../XSelector";
export default function Index(props) {
  var field = props.field;
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    valuelist = _useState2[0],
    setvaluelist = _useState2[1];
  var _useState3 = useState(),
    _useState4 = _slicedToArray(_useState3, 2),
    resultType = _useState4[0],
    setresultType = _useState4[1];
  var _useState5 = useState((field === null || field === void 0 ? void 0 : field.INPUT_TYPE) || ''),
    _useState6 = _slicedToArray(_useState5, 2),
    inputType = _useState6[0],
    setinputType = _useState6[1];
  var _useState7 = useState(props.value),
    _useState8 = _slicedToArray(_useState7, 2),
    selectValue = _useState8[0],
    setSelectValue = _useState8[1];
  var _useState9 = useState(false),
    _useState10 = _slicedToArray(_useState9, 2),
    open = _useState10[0],
    setOpen = _useState10[1];
  useUpdateEffect(function () {
    if (!open) {
      props.handleOnChange(selectValue);
    }
  }, [selectValue, open]);
  useEffect(function () {
    var _props$getResultTypeL, _props$getValueList;
    //获取结果数据
    // let x = props.onGetValueList?.(field)
    // setvaluelist(x)
    //获取结果类型
    var list = (_props$getResultTypeL = props.getResultTypeList) === null || _props$getResultTypeL === void 0 ? void 0 : _props$getResultTypeL.call(props, field.CLASS_ID);
    var d = list === null || list === void 0 ? void 0 : list.find(function (p) {
      return p.key === field.resultType;
    });
    setresultType(d);
    var data = (_props$getValueList = props.getValueList) === null || _props$getValueList === void 0 ? void 0 : _props$getValueList.call(props, field.CLASS_ID, d === null || d === void 0 ? void 0 : d.key, props.operator);
    setvaluelist(data);
    setinputType((data === null || data === void 0 ? void 0 : data.INPUT_TYPE) || field.INPUT_TYPE || '');
  }, [field]);
  var _useDebounceFn = useDebounceFn(function (e) {
      props.handleOnChange(e);
    }, {
      wait: 200
    }),
    run = _useDebounceFn.run;

  // 多选选中
  var onChangeSelect = function onChangeSelect(e) {
    var _valuelist$data;
    var list = cloneDeep(selectValue) || [];
    var x = valuelist === null || valuelist === void 0 || (_valuelist$data = valuelist.data) === null || _valuelist$data === void 0 ? void 0 : _valuelist$data.find(function (p) {
      return p.VALUE_ID === e || p.VALUE_NAME === e;
    });
    if (x) {
      //选择添加
      x.key = x.VALUE_ID;
      list.push(x);
    } else {
      //手动添加
      list.push({
        key: e,
        VALUE_ID: e,
        VALUE_NAME: e,
        isInput: '1'
      });
    }
    setSelectValue(list);
  };

  // 多选取消
  var onDeselect = function onDeselect(e) {
    if (selectValue && _typeof(selectValue) === 'object') {
      var data = selectValue.filter(function (p) {
        return p.VALUE_ID !== e;
      });
      setSelectValue(data);
    }
  };
  return /*#__PURE__*/React.createElement(Fragment, null, ((resultType === null || resultType === void 0 ? void 0 : resultType.resultType) || (field === null || field === void 0 ? void 0 : field.resultType_type)) !== 'none' && /*#__PURE__*/React.createElement(React.Fragment, null, ['MULTIPLE_SELECT', 'SELECT', 'TEXT+XSELECT', 'TEXT+MULTIPLE_XSELECT'].includes(inputType) && /*#__PURE__*/React.createElement(XSelector, {
    style: {
      minWidth: field.width || '140px'
    },
    defaultValue: _typeof(selectValue) === 'object' ? selectValue : [],
    onSelectChange: function onSelectChange(e) {
      var isEqual = eq(e, props.value);
      if (!isEqual) {
        setSelectValue(e);
      }
    },
    onDropdownOpen: function onDropdownOpen(open) {
      setOpen(open);
    },
    maxTagCount: 10,
    mode: ['SELECT', 'TEXT+XSELECT'].includes(inputType) ? undefined : 'multiple',
    dropdownStyle: {
      width: (valuelist === null || valuelist === void 0 ? void 0 : valuelist.dropSelectWidth) || '430px'
    },
    valueRow: "VALUE_ID",
    nameRow: "VALUE_NAME",
    colDef: (valuelist === null || valuelist === void 0 ? void 0 : valuelist.colDef) || [],
    data: valuelist === null || valuelist === void 0 ? void 0 : valuelist.data,
    showSearch: true,
    enterAdd: inputType.indexOf('TEXT') > -1
  }), inputType === 'TEXT+MULTIPLE_SELECT' && /*#__PURE__*/React.createElement(_Select, {
    mode: "tags",
    showSearch: true,
    style: {
      minWidth: field.width || '150px',
      maxWidth: '500px'
    },
    defaultValue: props.value,
    fieldNames: {
      value: 'VALUE_ID',
      label: 'VALUE_NAME'
    },
    filterOption: function filterOption(input, option) {
      var _option$VALUE_NAME;
      return ((_option$VALUE_NAME = option === null || option === void 0 ? void 0 : option.VALUE_NAME) !== null && _option$VALUE_NAME !== void 0 ? _option$VALUE_NAME : '').includes(input);
    },
    options: (valuelist === null || valuelist === void 0 ? void 0 : valuelist.data) || props.value,
    dropdownStyle: {
      width: (valuelist === null || valuelist === void 0 ? void 0 : valuelist.dropSelectWidth) || '430px'
    },
    onSelect: onChangeSelect,
    onDeselect: onDeselect,
    onDropdownVisibleChange: function onDropdownVisibleChange(open) {
      setOpen(open);
    }
  }), inputType === 'AUTOCOMPLETE' && /*#__PURE__*/React.createElement(_AutoComplete, {
    showSearch: true,
    style: {
      minWidth: field.width || '150px',
      maxWidth: '500px'
    },
    defaultValue: props.value,
    fieldNames: {
      value: 'VALUE_ID',
      label: 'VALUE_NAME'
    },
    filterOption: function filterOption(input, option) {
      var _option$VALUE_NAME2;
      return ((_option$VALUE_NAME2 = option === null || option === void 0 ? void 0 : option.VALUE_NAME) !== null && _option$VALUE_NAME2 !== void 0 ? _option$VALUE_NAME2 : '').includes(input);
    },
    options: valuelist === null || valuelist === void 0 ? void 0 : valuelist.data,
    dropdownMatchSelectWidth: (valuelist === null || valuelist === void 0 ? void 0 : valuelist.dropSelectWidth) || 200,
    onSelect: function onSelect(e) {
      props.handleOnChange(e);
    },
    onBlur: function onBlur(e) {
      props.handleOnChange(e.target.value);
    }
  }), inputType === 'NUMBER' && /*#__PURE__*/React.createElement(_InputNumber, {
    style: {
      width: field.width || '150px',
      minWidth: '50px'
    },
    defaultValue: props.value,
    onBlur: function onBlur(e) {
      // run(e.target.value)
      props.handleOnChange(e.target.value);
    }
  }), inputType === 'TEXT' && /*#__PURE__*/React.createElement(_Input, {
    style: {
      height: 28,
      width: field.width || '150px',
      minWidth: field.width || '50px'
    },
    defaultValue: props.value,
    onBlur: function onBlur(e) {
      // run(e.target.value)
      props.handleOnChange(e.target.value);
    }
  }), inputType === 'DATE' && /*#__PURE__*/React.createElement("div", {
    style: {
      minWidth: field.width || '100px'
    }
  }, /*#__PURE__*/React.createElement(XDatePicker, {
    formatter: "YYYY-MM-DD",
    value: moment(props.value),
    onChange: function onChange(e) {
      run(e);
    },
    smallsizePop: true,
    showTimeSelect: false
  })), inputType === 'DATE_TIME' && /*#__PURE__*/React.createElement("div", {
    style: {
      minWidth: field.width || '120px'
    }
  }, /*#__PURE__*/React.createElement(XDatePicker, {
    formatter: "YYYY-MM-DD HH:mm",
    value: moment(props.value),
    onChange: function onChange(e) {
      run(e);
    },
    smallsizePop: true
  }))));
}