/*
 * @Author: chenzenghua
 * @Date: 2023-03-01 11:28:30
 * @LastEditTime: 2023-06-26 10:08:00
 * @LastEditors: chenzenghua
 * @Description: 
 */
import { isArray, toNumber } from "lodash";
import { cloneDeep } from 'lodash';

/**
 * 去掉非数组字符,并转成纯数字字符数组
 * @param value 
 * @returns 
 */
export var toNumberArray = function toNumberArray(value) {
  if (!value) {
    return undefined;
  }
  if (!isArray(value)) {
    console.log("toNumberArray:参数非数组");
    return undefined;
  }
  var arr = cloneDeep(value);
  arr.forEach(function (item, index) {
    arr[index] = toNumber(item);
  });
  arr = arr.filter(function (p) {
    return !isNaN(p);
  });
  return arr;
};