/**
 * 条码、回执单打印
 * @param DataXml
 * @param PrintXml
 * @returns
 */
declare function BarcodePrint(DataXml: string, PrintXml: string): Promise<any>;
/**
 * 条码、回执单打印
 * @param DataXml
 * @returns
 */
declare function BarcodePrint6(DataXml: string): Promise<any>;
/**
 * 取号单打印
 * @param PrintXml
 * @returns
 */
declare function BarcodeNumberPrint(PrintXml: string): Promise<any>;
/**
 * 单张PDF报告打印/生成
 * @param DataXml
 * @returns
 */
declare function ExportPdfReport(DataXml: string): Promise<any>;
/**
 * 汇总PDF报告打印/生成
 * @param sumType
 * @param DataXml
 * @returns
 */
declare function ExportSumPdfReport(sumType: string, DataXml: string): Promise<any>;
/**
 * PDF单据打印
 * @param DataXml
 * @returns
 */
declare function PrintPdfReport(DataXml: string): Promise<any>;
/**
 * 其他PDF单据打印/生成
 * @param DataXml
 * @returns
 */
declare function ExportPdfOtherSheet(DataXml: string): Promise<any>;
/**
 * 6.0单据打印/生成
 * @param DataXml
 * @returns
 */
declare function ExportPdfSheet6(DataXml: string): Promise<any>;
/**
 * 环境卫生学条码打印
 * @param DataXml
 * @param PrintXml
 * @returns
 */
declare function EHMBarcodePrint(DataXml: string, PrintXml: string): Promise<any>;
/**
 * 单张PDF报告打印/生成
 * @param DataXml
 * @returns
 */
declare function EHMExportPdfReport(DataXml: string): Promise<any>;
declare const XPrint: {
    BarcodePrint: typeof BarcodePrint;
    BarcodePrint6: typeof BarcodePrint6;
    BarcodeNumberPrint: typeof BarcodeNumberPrint;
    ExportPdfReport: typeof ExportPdfReport;
    ExportSumPdfReport: typeof ExportSumPdfReport;
    PrintPdfReport: typeof PrintPdfReport;
    EHMExportPdfReport: typeof EHMExportPdfReport;
    EHMBarcodePrint: typeof EHMBarcodePrint;
    ExportPdfSheet6: typeof ExportPdfSheet6;
    ExportPdfOtherSheet: typeof ExportPdfOtherSheet;
};
export default XPrint;
